program Arbore;
const   NMaxVf   = 100;
        nfin='arbore.in';
        nfout='arbore.out';
type    Vf       = -1 .. NMaxVf;
        Muchie = record x,y: Vf; end;
        Graf=array[Vf, Vf] of Vf;
var     n, rad, nr, nrezolv, i, j, nrterminali, t1, t2, lg, k, v, nrfire2, nrfire: Vf;
        MC: array[Vf] of Muchie;
        tata, d, sus1, sus2 : array[Vf] of Vf;
        ok, t_unit: boolean;
        G: Graf;

procedure DFS (x, tx: Vf);
var    i: Vf;
begin
if tata[x]=-1 then
   begin
   tata[x]:=tx;
   for i:=1 to G[x][0] do
       if (tx<>G[x][i]) then DFS(G[x,i],x)
   end

end;

procedure Initializare;
var fin: text;
    i, x, y: Vf;
begin
assign(fin, nfin); reset(fin);
readln(fin, n);
for i:= 1 to n-1 do
    begin
    readln(fin, x, y); inc(d[x]); inc(d[y]);
    inc (G[x,0]); G[x][G[x,0]]:=y;
    inc (G[y,0]); G[y][G[y,0]]:=x;
    end;
close(fin);
rad:=1; while d[rad]=1 do inc(rad);
for i := 1 to n do tata[i]:=-1;
DFS (rad, 0);
for i := 1 to n do dec(d[i]); inc(d[rad]);
end;

procedure Afisare;
var fout: text;
    i: Vf;
begin
assign(fout, nfout); rewrite(fout);
if not ok or (nrezolv<>n) then writeln(fout, -1)
   else
   begin
   writeln(fout, nr);
   for i:=1 to nr do    writeln(fout, MC[i].x, ' ',MC[i].y);
   end;
close(fout);
end;

procedure DeterminSus;
var  i: Vf;
begin
for i:=1 to n do begin sus1[i]:=-1; sus2[i]:=-1; end;
for i:=1 to n do
    if d[i]=0 then {varf terminal}
       begin
       sus1[i]:=i; sus2[i]:=tata[i];
       while (sus2[i]<>0) and (d[sus2[i]]=1) do
             begin
             j:=sus2[i]; sus1[j]:=j;
             sus1[i]:=sus2[i]; sus2[i]:=tata[sus2[i]];
             sus2[j]:=sus2[i];
             end;
       end;
end;

function Rezolvabil(x: Vf): boolean;
var  i: Vf;
begin
Rezolvabil:=false;
if (d[x]>1) or (d[x]=1) and (x=rad) then
   begin
   Rezolvabil:=true;
   for i:=1 to G[x,0] do
       if G[x,i]<>tata[x] then
       if (d[G[x,i]]<>-1) and (sus2[G[x,i]]=-1) then begin Rezolvabil:=false; break; end;
   end;
end;

begin {program principal}
Initializare;
ok:=true; nr:=0; nrezolv:=0;
repeat
DeterminSus;
for i:= 1 to n do
    if Rezolvabil(i) then
       begin
       nrterminali:=0; t1:=-1; t2:=-1;
       for j:=1 to G[i,0] do
           if G[i,j]<>tata[i] then
           if{ (d[G[i,j]]<>-1) and (sus1[G[i,j]]=G[i,j]) }d[G[i,j]]=0 then
              begin
              inc(nrterminali);
              t1:=t2; t2:=G[i,j];
              end;
       if (nrterminali > 2) then ok:=false
          else
          if (nrterminali=2) then
             begin
             inc(nr); MC[nr].x:=t1; MC[nr].y:=t2; {unesc terminalii}
             d[t1]:=-1; d[t2]:=-1; nrezolv:=nrezolv+3;
             if tata[i]<>0 then dec(d[tata[i]]);
             if d[i]>2 then {rezolv firele}
                begin
                for j:=1 to G[i,0] do
                    if G[i,j]<>tata[i] then
                    if d[G[i,j]]<>-1 then
                       begin
                       inc(nr); MC[nr].x:=G[i,j];
                       lg:=1; k:=G[i,j];
                       while d[k]>0 do
                             for v:=1 to G[k,0] do
                                 if G[k,v]<>tata[k] then
                                 if d[G[k,v]]<>-1 then
                                    begin  d[k]:=-1; k:=G[k,v]; inc(lg); break; end;
                       if lg=2 then ok:=false
                          else
                          begin MC[nr].y:=k; nrezolv:=nrezolv+lg; end;
                        end;
                end;
                d[i]:=-1;
             end
             else
             if nrterminali = 1 then
                begin
                {rezolv firele}
                t_unit:=false; d[i]:=-1; dec(d[tata[i]]);
                for j:=1 to G[i,0] do
                    if G[i,j]<>tata[i] then
                    if d[G[i,j]]>0 then
                       begin
                       inc(nr); MC[nr].x:=G[i,j];
                       lg:=1; k:=G[i,j];
                       while d[k]>0 do
                             for v:=1 to G[k,0] do
                                 if G[k,v]<>tata[k] then
                                 if d[G[k,v]]<>-1 then
                                    begin  d[k]:=-1; k:=G[k,v]; inc(lg); break; end;
                       if (lg=2) then
                          if t_unit then ok:=false
                             else
                             begin
                             MC[nr].x:=t2; MC[nr].y:=k; nrezolv:=nrezolv+lg+2;
                             t_unit:=true;
                             end
                          else
                          begin MC[nr].y:=k; nrezolv:=nrezolv+lg; end;
                        end;
                 if not t_unit then
                    begin MC[nr].x:=t2; inc(nrezolv, 2); end;
                end
                else {nu exista terminali}
                begin
                {rezolv firele}
                d[i]:=-1; dec(d[tata[i]]);
                nrfire2:=0; t1:=0; t2:=0; nrfire:=0;
                for j:=1 to G[i,0] do
                    if G[i,j]<>tata[i] then
                    if d[G[i,j]]>0 then
                       begin
                       lg:=1; k:=G[i,j];
                       while d[k]>0 do
                             for v:=1 to G[k,0] do
                                 if d[G[k,v]]<>-1 then
                                    begin  d[k]:=-1; k:=G[k,v]; inc(lg); break; end;
                       inc(nrfire);
                       if (lg=2) then
                          begin inc(nrfire2); t1:=t2; t2:=k; end
                          else
                          begin
                          inc(nr); MC[nr].x:=G[i,j];
                          MC[nr].y:=k; nrezolv:=nrezolv+lg;
                          end;
                        end;
                 if nrfire2>2 then ok:=false
                    else
                    if nrfire2=2 then
                       begin
                       inc(nr); MC[nr].x:=t1; MC[nr].y:=t2; nrezolv:=nrezolv+5;
                       end
                       else
                       if nrfire2=1 then
                          if nrfire=1 then begin inc(nr); MC[nr].x:=t2; MC[nr].y:=i; inc(nrezolv, 3); end
                          else
                          begin MC[nr].x:=t2; inc(nrezolv, 3); end
                          else
                          if nrfire>=2 then
                             begin MC[nr-1].x:=MC[nr].y; dec(nr); inc(nrezolv); end;
                end;
             end;
until not ok or (nrezolv>=n-2);
Afisare;
end.



