{ Mugurel Ionut Andreica - Bucuresti, ROMANIA }

Program SISTEM;

const filein='SISTEM.IN';
      fileout='SISTEM.OUT';
      MAXN=100;
      NCIFRE=55;
      baza=10000;
      vmax=9999;
      avans=2;

type NMARE=array[0..NCIFRE] of integer;
     pNMARE=^NMARE;
     NMAREvect=array[0..MAXN] of NMARE;

var fin,fout:text;
    n2g,fact:array[0..MAXN] of NMARE;
    comb:array[0..MAXN] of ^NMAREvect;
    i,j,k,m,n,p:integer;
    act,naux,naux2:NMARE;

procedure adunanm(n1,n2:pNMARE;rez:pNMARE);
var r,co,tt:integer;
begin
if (n1^[0]>n2^[0]) then
  r:=n1^[0]
else
  r:=n2^[0];

fillchar(rez^,sizeof(NMARE),0);
tt:=0;
for co:=1 to r+avans do
  begin
    rez^[co]:=rez^[co]+n1^[co]+n2^[co];
    tt:=rez^[co] div baza;
    rez^[co]:=rez^[co] mod baza;
    rez^[co+1]:=rez^[co+1]+tt;
  end;

for co:=r+avans downto 1 do
  if (rez^[co]>0) then
    begin
      rez^[0]:=co;
      break;
    end;
end;

procedure inmul(n1:pNMARE;x:longint;rez:pNMARE);
var r,co:integer;
    tt:longint;
begin
fillchar(rez^,sizeof(NMARE),0);
for co:=1 to n1^[0]+avans do
  begin
    tt:=n1^[co];
    tt:=tt*x;
    rez^[co]:=rez^[co]+(tt mod baza);
    rez^[co+1]:=tt div baza;

    tt:=rez^[co] div baza;
    rez^[co]:=rez^[co] mod baza;
    rez^[co+1]:=rez^[co+1]+tt;
  end;

for co:=n1^[0]+avans downto 1 do
  if (rez^[co]>0) then
    begin
      rez^[0]:=co;
      break;
    end;
end;

procedure imparte2(n1:pNMARE;rez:pNMARE);
var r,cif,ncf:integer;
begin
fillchar(rez^,sizeof(NMARE),0);
cif:=n1^[0]+1;
ncf:=0;

r:=0;
while (r<2) do
  begin
    dec(cif);
    r:=r*baza+n1^[cif];
  end;

inc(ncf);
rez^[ncf]:=r shr 1;
r:=r and 1;

for cif:=cif-1 downto 1 do
  begin
    inc(ncf);
    r:=r*baza+n1^[cif];
    rez^[ncf]:=r shr 1;
    r:=r and 1;
  end;

rez^[0]:=ncf;
for r:=1 to (ncf div 2) do
  begin
    cif:=rez^[r];
    rez^[r]:=rez^[ncf-r+1];
    rez^[ncf-r+1]:=cif;
  end;
end;

procedure inmulnm(nn1,nn2:pNMARE;rrez:pNMARE);
var rr,cco:integer;
    nnaux,nnaux2:NMARE;
begin
fillchar(rrez^,sizeof(NMARE),0);
for rr:=1 to nn1^[0] do
  begin
    inmul(nn2,nn1^[rr],@nnaux);

    for cco:=nnaux[0]+rr-1 downto rr do
      nnaux[cco]:=nnaux[cco-rr+1];
    for cco:=1 to rr-1 do
      nnaux[cco]:=0;
    nnaux[0]:=nnaux[0]+rr-1;

    adunanm(@nnaux,rrez,@nnaux2);
    move(nnaux2,rrez^,sizeof(NMARE));
  end;
end;

begin
assign(fin,filein);
reset(fin);
readln(fin,n);
close(fin);

{ FACTORIALS }
fillchar(fact[0],sizeof(NMARE),0);
fact[0][0]:=1;
fact[0][1]:=1;

for i:=1 to n do
  inmul(@fact[i-1],i,@fact[i]);
{ END FATORIALS }

{ COMBINATIONS }
new(comb[2]);
fillchar(comb[2]^,sizeof(NMAREvect),0);
for j:=0 to 2 do
  begin
    comb[2]^[j][0]:=1;

    if (j=1) then
      comb[2]^[j][1]:=2
    else
      comb[2]^[j][1]:=1;
  end;
{ END COMBINATIONS }

fillchar(n2g[0],sizeof(NMARE),0);
n2g[0][0]:=1;
n2g[0][1]:=1;

for i:=3 to n do
  begin

    new(comb[i]);
    fillchar(comb[i]^,sizeof(NMAREvect),0);

    for j:=0 to i do
      begin
        if (j=0) or (j=i) then
          begin
            comb[i]^[j][0]:=1;
            comb[i]^[j][1]:=1;
          end
        else
          begin
            adunanm(@comb[i-1]^[j],@comb[i-1]^[j-1],@comb[i]^[j]);
            {
            comb[i,j]:=comb[i-1,j]+comb[i-1,j-1];
            }
          end;
      end;

    fillchar(n2g[i],sizeof(NMARE),0);

    for j:=2 to i-1 do
      if (i-j-1<>1) and (i-j-1<>2)
      then
        begin
        {
          act:=(comb[i-1,j]*fact[j]*n2g[i-j-1])/2;
          n2g[i]:=n2g[i]+act;
        }
          inmulnm(@comb[i-1]^[j],@fact[j],@naux);
          inmulnm(@naux,@n2g[i-j-1],@naux2);
          imparte2(@naux2,@act);

          adunanm(@act,@n2g[i],@naux);
          move(naux,n2g[i],sizeof(NMARE));
      end;

    dispose(comb[i-1]);
  end;

assign(fout,fileout);
rewrite(fout);

write(fout,n2g[n][n2g[n][0]]);
for i:=n2g[n][0]-1 downto 1 do
  begin
    p:=baza div 10;
    while (p>0) do
      begin
        write(fout,(n2g[n][i] div p) mod 10);
        p:=p div 10;
      end;
  end;

writeln(fout);
close(fout);
end.