{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
uses crt;
var i,j,k,l,m,n,p,d,dir:longint;
    ch:char;
    fi,fo,fsol:text;
    s,cow:array[1..1000]of char;
    a:array[0..101,0..101]of integer;
    i1,j1,i2,j2:integer;
    ss:string;

procedure genMatrix;
begin
  for i:=0 to m+1 do
      for j:=0 to n+1 do
          a[i,j]:=1;

  for i:=1 to m do
      for j:=1 to n do
          if random(4)=0 then
             a[i,j]:=1
             else
             a[i,j]:=0;
  a[1,1]:=0;
  a[1,2]:=0;
  a[2,1]:=0;
  a[m,n]:=0;
  a[m-1,n]:=0;
  a[m,n-1]:=0;
end;

procedure save;
begin
  writeln('Enter input file name:');
  readln(ss);
  assign(fo,ss);
  writeln('Enter solution file name:');
  readln(ss);
  assign(fsol,ss);
  rewrite(fo);
  rewrite(fsol);

  writeln(fo,m,' ',n);
  for i:=1 to m do
      begin
        write(fo,a[i,1]);
        for j:=2 to n do
          write(fo,' ',a[i,j]);
        writeln(fo);
      end;
  writeln(fo,i1,' ',j1,' ',i2,' ',j2);
  writeln(fo,k);
  for i:=1 to k do
      write(fo,s[i]);
  for i:=1 to k do
      write(fsol,cow[i]);
  close(fo);
  close(fsol);
end;

procedure load;
begin
  writeln('Type Matrix File Name:');
  readln(ss);
  assign(fi,ss);
  reset(fi);
  readln(fi,m,n);
  for i:=0 to m+1 do
      for j:=0 to n+1 do
          a[i,j]:=1;
  for i:=1 to m do
      for j:=1 to n do
          read(fi,a[i,j]);
  i1:=1;j1:=1;
  i2:=m;j2:=n;
  k:=0;
  close(fi);
end;

procedure moveCowA(i,j:integer);
begin
  if a[i1+i,j1+j]=0 then
     begin
       inc(k);
       cow[k]:='A';
       if (i=-1)and(j=0) then
          s[k]:='N';
       if (i=0)and(j=1) then
          s[k]:='E';
       if (i=1)and(j=0) then
          s[k]:='S';
       if (i=0)and(j=-1) then
          s[k]:='V';
       i1:=i1+i;
       j1:=j1+j;
     end;
end;

procedure moveCowB(i,j:integer);
begin
  if a[i2+i,j2+j]=0 then
     begin
       inc(k);
       cow[k]:='B';
       if (i=-1)and(j=0) then
          s[k]:='N';
       if (i=0)and(j=1) then
          s[k]:='E';
       if (i=1)and(j=0) then
          s[k]:='S';
       if (i=0)and(j=-1) then
          s[k]:='V';
       i2:=i2+i;
       j2:=j2+j;
     end;
end;

procedure printScreen;
var i,j:integer;
begin
  for i:=0 to m+1 do
      begin
        for j:=0 to n+1 do
            begin
              if a[i,j]=1 then
                 write('#')
                 else
                 if (i1=i)and(j1=j)and(i2=i)and(j2=j) then
                    write('X')   {both cows}
                 else
                 if (i1=i)and(j1=j) then
                    write('R')
                 else
                 if (i2=i)and(j2=j) then
                    write('J')
                    else
                    write(' ');

            end;
        writeln;
      end;
  writeln(' Romeo:',i1:3,j1:3,'         K: ',k);
  writeln('Juliet:',i2:3,j2:3);
end;

procedure genWalk;
begin
  i1:=1;
  j1:=1;
  i2:=m;
  j2:=n;

  ch:=' ';
  k:=0;
  while ch<>'q' do
    begin
      {
        q - quit
        s - save
        l - load
        r,d,f,g - move cow A
        u,h,j,k - move cow B
      }
      printScreen;
      ch:=readkey;
      if ch='s' then
         save;
      if ch='q' then
         halt;
      if ch='l' then
         load;

      if ch='r' then
         moveCowA(-1,0);
      if ch='g' then
         moveCowA(0,1);
      if ch='f' then
         moveCowA(1,0);
      if ch='d' then
         moveCowA(0,-1);

      if ch='u' then
         moveCowB(-1,0);
      if ch='k' then
         moveCowB(0,1);
      if ch='j' then
         moveCowB(1,0);
      if ch='h' then
         moveCowB(0,-1);

    end;


end;

begin
  writeln('Enter values for m (3<=m<=20) and n (3<=n<=60):');
  readln(m,n);

  randomize;
  genMatrix;
  genWalk;

end.