{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
const dirs='NESV';
type matrix=array[0..21,0..61]of char;
var fi,fo:text;
    sx,sy:array[0..200]of integer;
    step,i,j,k,l,m,n,ii,jj:longint;
    i1,j1,i2,j2:integer;
    a:array[0..31,0..81]of integer;
    dp:array[0..200]of ^matrix;
    s:array[1..200] of char;

procedure readdata;
begin
  assign(fi,'labirint.in');
  assign(fo,'labirint.out');
  reset(fi);
  readln(fi,m,n);
  for i:=0 to m+1 do
      for j:=0 to n+1 do
          a[i,j]:=1;
  for i:=1 to m do
      for j:=1 to n do
          read(fi,a[i,j]);
  readln(fi,i1,j1,i2,j2);
  readln(fi,k);
  for i:=1 to k do
      read(fi,s[i]);
  close(fi);
end;

procedure init;
begin
  for l:=0 to k do
      begin
        new(dp[l]);
        for i:=0 to m+1 do
            for j:=0 to n+1 do
                dp[l]^[i,j]:='x'; { can't reach that point }
      end;

  dp[0]^[1,1]:='O';     { start position }
  sx[0]:=m+1;
  sy[0]:=n+1;
  for i:=1 to k do
      begin
        if s[i]='N' then
           begin
             sx[i]:=sx[i-1]-1;
             sy[i]:=sy[i-1];
           end;
        if s[i]='E' then
           begin
             sx[i]:=sx[i-1];
             sy[i]:=sy[i-1]+1;
           end;
        if s[i]='S' then
           begin
             sx[i]:=sx[i-1]+1;
             sy[i]:=sy[i-1];
           end;
        if s[i]='V' then
           begin
             sx[i]:=sx[i-1];
             sy[i]:=sy[i-1]-1;
           end;
      end;
  if (i1+i2<>sx[k])or(j1+j2<>sy[k]) then
     begin
       writeln('Invalid Test Case - no solution!!!');
       halt;
     end;
end;

procedure rec(step,i1,j1:integer);
begin
  if step=0 then exit;
  if dp[step]^[i1,j1]='J' then
     rec(step-1,i1,j1)
     else
     if dp[step]^[i1,j1]='R' then
        begin
          if s[step]='N' then
             rec(step-1,i1+1,j1);
          if s[step]='E' then
             rec(step-1,i1,j1-1);
          if s[step]='S' then
             rec(step-1,i1-1,j1);
          if s[step]='V' then
             rec(step-1,i1,j1+1);
        end
        else
        begin
          writeln('ERROR');
          halt;
        end;

  write(fo,dp[step]^[i1,j1]);
end;

procedure writeOutput;
begin
  rewrite(fo);
  rec(k,i1,j1);

  close(fo);
end;

procedure solve;
begin
  init;
  for step:=1 to k do
      begin
        for i:=1 to m do
            for j:=1 to n do
                begin
                  ii:=sx[step]-i;
                  jj:=sy[step]-j;

                  if (ii>0)and(jj>0)and(ii<m+1)and(jj<n+1) then
                     if (a[i,j]=0)and(a[ii,jj]=0) then
                        begin
                          if s[step]='N' then
                             begin
                               if dp[step-1]^[i,j]<>'x' then
                                  dp[step]^[i,j]:='J';
                               if dp[step-1]^[i+1,j]<>'x' then
                                  dp[step]^[i,j]:='R';
                             end;
                          if s[step]='E' then
                             begin
                               if dp[step-1]^[i,j]<>'x' then
                                  dp[step]^[i,j]:='J';
                               if dp[step-1]^[i,j-1]<>'x' then
                                  dp[step]^[i,j]:='R';
                             end;
                          if s[step]='S' then
                             begin
                               if dp[step-1]^[i,j]<>'x' then
                                  dp[step]^[i,j]:='J';
                               if dp[step-1]^[i-1,j]<>'x' then
                                  dp[step]^[i,j]:='R';
                             end;
                          if s[step]='V' then
                             begin
                               if dp[step-1]^[i,j]<>'x' then
                                  dp[step]^[i,j]:='J';
                               if dp[step-1]^[i,j+1]<>'x' then
                                  dp[step]^[i,j]:='R';
                             end;
                        end;
                end;
      end;
  if dp[k]^[i1,j1]<>'x' then
     begin
       writeOutput;
       halt;
     end
     else
     begin
       writeln('Invalid Test Case - no solution!!!');
       halt;
     end;
end;

begin
  readdata;
  solve;
end.