unit mon;

interface

type taler=array[0..999] of byte;

function init:integer;
function cantarire(var stanga, dreapta : taler):integer;
procedure rezultat(moneda, tip:integer);
procedure setcant(sk,st:integer);

implementation

var apelat_init:boolean;
    n, k, t, cant_nr:integer;

procedure setcant(sk,st:integer);
begin
  cant_nr:=0;k:=sk;t:=st;
end;

function de(a:integer):integer;
begin
  de:=a div 2;
end;

var fo:text; const foname='monede.out';

function init:integer;
var f:text; const fname='monede.in';
begin
  {$i-}
  assign(f, fname); reset(f); assign(fo, foname);rewrite(fo);
  if ioresult<>0 then begin
    Writeln(fo, 'EROARE Nu pot deschide fisierul MONEDE.in');
    close(fo);
    halt(0);
  end;
  read(f, n, k, t);
  if (ioresult<>0) or (de(n)<3) or (de(n)>1000) or (de(k)<0) or (de(k)>=de(n))
     or ((de(t)<>1) and (de(t)<>-1)) then begin
    Writeln(fo, 'EROARE Fisierul MONEDE.in nu respecta formatul cerut');
    close(fo);
    halt(0);
  end;
  close(f);
  {$i+}
  apelat_init := true;
  init:=de(n);
  flush(fo);
end;

function cantarire(var stanga, dreapta : taler):integer;
var i, s, d: integer;
begin
  if not apelat_init then begin
    writeln(fo, 'KO Apel pentru cantarire inainte de init');
    close(fo);
    halt(0);
  end;
  cantarire := 0; s:=0; d:=0;
  for i:=0 to de(n)-1 do begin
    if (stanga[i]<0) or (stanga[i]>1) or
       (dreapta[i]<0) or (dreapta[i]>1) or
       ((dreapta[i]=1) and (stanga[i]=1)) then begin
       writeln(fo, 'KO Apel incorect pentru cantarire');
       close(fo);
       halt(0);
    end;
    if stanga[i]=1 then begin
      s := s+1;
      if i = de(k) then cantarire := de(t);
    end;
    if dreapta[i]=1 then begin
      d := d+1;
      if i = de(k) then cantarire := -de(t);
    end;
  end;
  if s<>d then begin
    writeln(fo, 'KO Apel incorect pentru cantarire');
    close(fo);
    halt(0);
  end;
  inc(cant_nr);
  writeln(fo, 'CANTARIRE ', cant_nr);
  flush(fo);
end;

procedure rezultat(moneda, tip:integer);
begin
  if not apelat_init then begin
    writeln(fo, 'KO Apel pentru rezultat inainte de init');
    close(fo);
    halt(0);
  end;
  if (moneda<>de(k)) or (tip<>de(t)) then
    writeln(fo,'KO Rezultat incorect')
  else
    Writeln(fo, 'REZULTAT ', moneda, ' ', tip);
  close(fo);
  halt(0);
end;

begin
  cant_nr:=0;
  apelat_init:=false;
end.