unit mon;
interface
type taler=array[0..999] of byte;
function init:integer;
function cantarire(var stanga, dreapta : taler):integer;
procedure rezultat(moneda, tip:integer);
procedure setcant(sk,st:integer);

implementation
var apelat_init:boolean;
    cant_nr, n ,k, t:integer;

procedure setcant(sk,st:integer);
begin
  cant_nr:=0;k:=sk;t:=st;
end;

function init:integer;
var f:text; const fname='monede.in';
begin
  {$i-}
  assign(f, fname); reset(f);
  if ioresult<>0 then begin
    Writeln('*** Nu pot deschide fisierul MONEDE.in');
    Writeln('*** Cititi explicatiile din textul problemei');
    halt(0);
  end;
  read(f, n, k, t);
  if (ioresult<>0) or (n<3) or (n>1000) or (k<0) or (k>=n)
     or ((t<>1) and (t<>-1)) then begin
    Writeln('*** Fisierul MONEDE.in nu respecta formatul cerut');
    Writeln('*** Cititi explicatiile din textul problemei');
    halt(0);
  end;
  close(f);
  {$i+}
  apelat_init := true;
  init:=n;
end;

function cantarire(var stanga, dreapta : taler):integer;
var i, s, d: integer;
begin
  if not apelat_init then begin
    writeln('*** Apel pentru cantarire inainte de init');
    halt(0);
  end;
  cantarire := 0; s:=0; d:=0;
  for i:=0 to n-1 do begin
    if (stanga[i]<0) or (stanga[i]>1) or
       (dreapta[i]<0) or (dreapta[i]>1) or
       ((dreapta[i]=1) and (stanga[i]=1)) then begin
       writeln('*** Apel incorect pentru cantarire');
       halt(0);
    end;
    if stanga[i]=1 then begin
      s := s+1;
      if i = k then cantarire := t;
    end;
    if dreapta[i]=1 then begin
      d := d+1;
      if i = k then cantarire := -t;
    end;
  end;
  if s<>d then begin
    writeln('*** Apel incorect pentru cantarire');
    halt(0);
  end;
  inc(cant_nr);
  writeln('Cantarire ', cant_nr, ' !');
end;

procedure rezultat(moneda, tip:integer);
begin
  if not apelat_init then begin
    writeln('*** Apel pentru rezultat inainte de init');
    halt(0);
  end;
  Writeln('*** Apel rezultat cu ', moneda, ' si ', tip);
  if (moneda<>k) or (tip<>t) then begin
    writeln('eroare');
    halt(0);
  end;
end;

begin
  cant_nr:=0;
  apelat_init:=false;
end.