{$A+,B-,D+,E+,F-,G-,I-,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 16384,0,655360}
const
  fin='banana.in';
  fout='banana.out';

type
  pelem=^elem;
  elem=record
    x,y,ind:integer;
    rep,next:pelem;
  end;

var
  f:text;

  nr:array[1..16000]of integer;
  n,k,i,x,y,mz:integer;
  sum:longint;
  hash:array[0..5530]of pelem;
  temp,temp2,act:pelem;

function add2hash(x,y:integer; parent:pelem):pelem;
var tmp,tmp1:pelem;
    col:integer;
begin
  col:=(longint(x)*longint(y))mod 5531;
  tmp:=hash[col];

  if tmp=nil then begin
    new(hash[col]);
    tmp:=hash[col];

  end else begin
    tmp1:=hash[col]^.next;

    while tmp1<>nil do begin
      tmp:=tmp1;
      tmp1:=tmp1^.next;
    end;

    new(tmp^.next);
    tmp:=tmp^.next;

  end;

  tmp^.next:=nil;
  tmp^.x:=x;
  tmp^.y:=y;
  tmp^.rep:=parent;
  tmp^.ind:=0;

  add2hash:=tmp;

end;

function inhash(x,y:integer):pelem;
var col:integer;
    tmp:pelem;
    gasit:boolean;
begin
  inhash:=nil;

  col:=(longint(x)*longint(y))mod 5531;
  gasit:=false;
  tmp:=hash[col];

  while (tmp<>nil) and not gasit do begin
    if (tmp^.x=x) and (tmp^.y=y) then gasit:=true;
  end;

  inhash:=tmp;
end;

procedure setparent(child,parent:pelem);
begin
  child^.rep:=parent;
end;

procedure sift(k:integer);
var t:integer;
    pos:integer;
    cade:boolean;
begin
  t:=k;
  cade:=true;
  while (t<=mz div 2) and cade do begin
    pos:=t*2;
    cade:=false;
    if (nr[pos]<nr[pos+1]) and (pos+1<=mz) then
		  pos:=pos+1;
    if nr[pos]>nr[t] then begin
      nr[pos]:=nr[pos] xor nr[t];
      nr[t]:=nr[t] xor nr[pos];
      nr[pos]:=nr[pos] xor nr[t];
      t:=pos;
      cade:=true;
    end;
  end;
end;

procedure buildheap;
begin
  for i:=mz div 2 downto 1 do sift(i);
end;

function extractmaxheap:integer;
begin
  extractmaxheap:=nr[1];
  nr[1]:=nr[1] xor nr[mz];
  nr[mz]:=nr[mz] xor nr[1];
  nr[1]:=nr[1] xor nr[mz];
  dec(mz);
  sift(1);
end;

begin
  assign(f,fin);
	reset(f);
    read(f,n,k);
    for i:=1 to n do begin
		  read(f,x,y);
      temp:=inhash(x-1,y);
      if temp<>nil then begin
        act:=add2hash(x,y,temp);
      end else
        act:=add2hash(x,y,nil);
      temp:=inhash(x+1,y);
      if temp<>nil then setparent(temp,act);
      temp:=inhash(x,y+1);
      if temp<>nil then setparent(temp,act);
      temp:=inhash(x,y-1);
      if temp<>nil then setparent(temp,act);
    end;
	close(f);
  for i:=0 to 5530 do begin
    temp:=hash[i];
    while temp<>nil do begin
      temp2:=temp;
      while temp2^.rep<>nil do
        temp2:=temp2^.rep;
      if (temp2^.rep=nil) and (temp2^.ind=0) then begin
        inc(mz);
			  temp2^.ind:=mz;
      end;
      inc(nr[temp2^.ind]);
      temp:=temp^.next;
		end;
  end;

  buildheap;
  for i:=1 to k do sum:=sum+extractmaxheap;

  assign(f,fout);
  rewrite(f);
    writeln(f,sum);
  close(f);

end.