#pragma option -O2 -3 -G -f287 -ff
#include <stdio.h>
#include <fstream.h>
#include <alloc.h>

#define MAXN (16002)

struct coordXY {
               int x, y;
       };

union Tcoord {
             long val;
             coordXY xy;
      };

struct Tree {
            int tata;
            int nr_ban;
       };

Tcoord huge coord[MAXN+1];
Tree huge dsj[MAXN+1];
int n, k, ban_sol=0, nr_zone;

Tree aux_d;
int m_d;

void quick_ds(int ic, int sf) {
do {
if (ic<sf) {
   m_d=dsj[(ic+sf)>>1].nr_ban;
   int i=ic, j=sf;
   do {
      while (dsj[i].nr_ban>m_d) i++;
      while (dsj[j].nr_ban<m_d) j--;
      if (i<=j) {
         aux_d=dsj[i];
         dsj[i]=dsj[j];
         dsj[j]=aux_d;
         i++; j--;
      }
   } while (i<=j);
   if ((j-ic)>(sf-i)) {
      quick_ds(i,sf);
      sf=j;
   }
   else {
        quick_ds(ic,j);
        ic=i;
   }
}
else return;
} while (1);
}

Tcoord m_c, aux_c;

void quick_c(int ic, int sf) {
do {
if (ic<sf) {
   m_c=coord[(ic+sf)>>1];
   int i=ic, j=sf;
   do {
      while (coord[i].val<m_c.val) i++;
      while (coord[j].val>m_c.val) j--;
      if (i<=j) {
         aux_c=coord[i];
         coord[i]=coord[j];
         coord[j]=aux_c;
         i++; j--;
      }
   } while (i<=j);
   if ((j-ic)>(sf-i)) {
      quick_c(i,sf);
      sf=j;
   }
   else {
        quick_c(ic,j);
        ic=i;
   }
}
else return;
} while (1);
}


void read() {
//     coord=(Tcoord*) malloc(sizeof(Tcoord)*(MAXN+1));
     FILE* in=fopen("banana.in","rt");
     fscanf(in,"%d %d",&n,&k);
     for (int i=1; i<=n; i++) {
         int auxx, auxy;
         fscanf(in,"%d %d",&auxx,&auxy);
         coord[i].xy.x=auxx;
         coord[i].xy.y=auxy;
     }
     fclose(in);
}

inline void sort_coord() {
       quick_c(1,n);
}

void init_disj() {
//     dsj=new Tree [MAXN+1];
     for (int i=1; i<=n; i++) {
         dsj[i].tata=i;
         dsj[i].nr_ban=1;
     }
}

int find_set(int a) {
    int t=dsj[a].tata;
    while (t!=dsj[t].tata) t=dsj[t].tata;
    while (a!=dsj[a].tata) {
          int tmp=a;
          a=dsj[a].tata;
          dsj[tmp].tata=t;
    }
    return t;
}

inline void reun(int t1, int t2) {
       if (dsj[t1].nr_ban>dsj[t2].nr_ban) {
          dsj[t2].tata=t1;
          dsj[t1].nr_ban+=dsj[t2].nr_ban;
          return;
       }
       dsj[t1].tata=t2;
       dsj[t2].nr_ban+=dsj[t1].nr_ban;
}

inline void merge_set(int t1, int t2) {
       t1=find_set(t1);
       t2=find_set(t2);
       if (t1!=t2) reun(t1,t2);
}

int m_b;

int rec_bin(int ic, int sf, long cau) {
    if (ic>sf) return 0;
    m_b=(ic+sf)>>1;
    if (coord[m_b].val==cau) return m_b;
    if (coord[m_b].val>cau) return rec_bin(ic,m_b-1,cau);
    return rec_bin(m_b+1,sf,cau);
}

inline int bin_find(long cau) {
       return rec_bin(1,n,cau);
}

inline void process(int nod) {
       Tcoord aux_c;
       int vec, x=coord[nod].xy.x, y=coord[nod].xy.y;

       aux_c.xy.x=x+1;
       aux_c.xy.y=y;
       vec=bin_find(aux_c.val);
       if (vec) merge_set(nod,vec);

       aux_c.xy.x=x-1;
       aux_c.xy.y=y;
       vec=bin_find(aux_c.val);
       if (vec) merge_set(nod,vec);

       aux_c.xy.x=x;
       aux_c.xy.y=y+1;
       vec=bin_find(aux_c.val);
       if (vec) merge_set(nod,vec);

       aux_c.xy.x=x;
       aux_c.xy.y=y-1;
       vec=bin_find(aux_c.val);
       if (vec) merge_set(nod,vec);
}

void kill_children() {
     nr_zone=0;
     for (int i=1; i<=n; i++)
         if (dsj[i].tata==i) dsj[++nr_zone]=dsj[i];
}

inline void sort_disj() {
       quick_ds(1,nr_zone);
}

void solve() {
     sort_coord();
     init_disj();
     for (int i=1; i<=n; i++) process(i);
     kill_children();
     sort_disj();
     ban_sol=0;
     for (i=1; i<=k; i++) ban_sol+=dsj[i].nr_ban;
     if (k==0) ban_sol=dsj[1].nr_ban;
}

void write() {
     ofstream out("banana.out");
     out<<ban_sol;
}

void main() {
     read();
     solve();
     write();
}