#pragma option -O2 -G -3 -f287 -ff
#include <fstream.h>

#define MAXN (102)
#define MAXSC (16002)
#define my_max(a,b) ( ((a)>(b)) ? (a) : (b) )

struct Tmunc {
             int l, p, s;
       };
int nr_sc, nr_mu;
Tmunc huge munc[MAXN+2];
long huge opt[MAXSC+1];
long nr_max=0;

void read() {
     ifstream in("gard.in");
     in>>nr_sc>>nr_mu;
     for (int i=1; i<=nr_mu; i++) {
         int auxl, auxp, auxs;
         in>>auxl>>auxp>>auxs;
         munc[i].l=auxl;
         munc[i].p=auxp;
         munc[i].s=auxs;
     }
}

void write() {
     ofstream out("gard.out");
     out<<nr_max;
}

int m;
Tmunc aux_q;

void quick(int ic, int sf) {
do {
if (ic<sf) {
   m=munc[(ic+sf)>>1].s;
   int i=ic, j=sf;
   do {
      while (munc[i].s<m) i++;
      while (munc[j].s>m) j--;
      if (i<=j) {
         aux_q=munc[i];
         munc[i]=munc[j];
         munc[j]=aux_q;
         i++; j--;
      }
   } while (i<=j);
   if ((j-ic)>(sf-i)) {
      quick(i,sf);
      sf=j;
   }
   else {
        quick(ic,j);
        ic=i;
   }
}
else return;
} while (1);
}

inline void sort_sc() {
       quick(1,nr_mu);
}

void solve() {
     sort_sc();
     munc[nr_mu+1].s=nr_sc;
     for (int cont=0; cont<=nr_sc; cont++) opt[cont]=0;
     for (int crt=1; crt<=nr_mu; crt++) {
         int ic_s=munc[crt].s, l=munc[crt].l, sf_s=ic_s+l-1, p=munc[crt].p;
         for (int cap=sf_s; cap>=ic_s; cap--) {
             long max=0;
             for (int i=my_max(cap-l+1,1); i<=cap; i++) {
                 long tmp_ct=opt[i-1]+p*(cap-i+1);
                 max=my_max(max,tmp_ct);
             }
             opt[cap]=my_max(opt[cap],max);
         }
         for ( cap=munc[crt+1].s; cap>sf_s; cap--)
             opt[cap]=my_max(opt[cap],opt[sf_s]);
     }
     nr_max=0;
     for (cont=0; cont<=nr_sc; cont++)
         nr_max<opt[cont] ? nr_max=opt[cont]: 0;
}

void main() {
     read();
     solve();
     write();
}