#include <stdio.h>
#include "mon.h"

taler ts, td;

int n;

int do_cantarire(int l, int r)
{
    int i, m, rez;
    int ns, nd;
    m=(l+r)/2;
    ns=nd=0;
    for(i=0;i<n;i++)
       ts[i]=td[i]=0;
    for(i=l;i<=r;i++) {
       if(i<=m) {
          ts[i]=1;
          ns++;
       } else {
          td[i]=1;
          nd++;
       }
    }
    rez=cantarire(ts, td);
    return rez;
}

void next_cantarire(int &l, int &r)
{
    int m, rez;
    m=(l+r)/2;
    if((l+m+1)%2)
      m++;
    rez=do_cantarire(l, m);
    if(rez==0) {
       l=m;
    } else {
       r=m;
    }
}

int buna(int a, int b)
{
    int i;
    for(i=0;i<n;i++)
      ts[i]=td[i]=0;
    ts[a]=1;
    td[b]=1;
    return(cantarire(ts, td));
}

void cauta_moneda(int l, int r)
{
    int i, j, sw;
    if(r-l<3) {
       if(l>0)
         l--;
       if(r<n-1)
         r++;
    }
    for(i=l;i<=r;i++) {
       sw=1;
       for(j=l;j<=r;j++)
          if(j!=i) {
             if(sw)
                sw=buna(i, j);
          }
       if(sw) {
          rezultat(i, sw);
          return;
       }
    }
}

void main(void)
{
    int l, r;
    n=init();
    l=0;
    r=n-1;
    while(l<r-4)
       next_cantarire(l, r);
    cauta_moneda(l, r);
}