#include<stdio.h>
#define nmax 16000
struct tree{
	int x,y,id;
};
struct node{
	int data;
	node*next;
};
int n,k,nc=0;
tree huge a[nmax]={0};
int huge b[nmax]={0};
node*c[nmax]={0};
int huge d[nmax]={0};

void read(void)
{
	FILE*fin=fopen("banana.in","rt");
	fscanf(fin,"%d%d",&n,&k);
	int t1,t2;
	for(int i=0;i<n;i++){
		fscanf(fin,"%d%d",&t1,&t2);
		a[i].x=t1;a[i].y=t2;
		a[i].id=i;
	}
	fclose(fin);
}

int cmp1(const tree x,const tree y)
{
	if(x.x<y.x)return -1;
	if(x.x>y.x)return 1;
	if(x.y<y.y)return -1;
	return 1;
}

int cmp2(const tree x,const tree y)
{
	if(x.y<y.y)return -1;
	if(x.y>y.y)return 1;
	if(x.x<y.x)return -1;
	return 1;
}

int cmp3(const int x,const int y)
{
	if(x>y)return -1;
	return x<y;
}

void push(node*&start,const int data)
{
	node*p=start;
	start=new node;
	start->next=p;
	start->data=data;
}

void step1(void)
{
	int i;
	b[a[0].id]=0;
	d[0]++;
	push(c[0],a[0].id);
	for(i=1;i<n;i++){
		if(a[i].x==a[i-1].x&&a[i].y==a[i-1].y+1)
			b[a[i].id]=b[a[i-1].id];
		else
			b[a[i].id]=++nc;
		push(c[b[a[i].id]],a[i].id);
		d[b[a[i].id]]++;
	}
}

int pop(node*&start)
{
	int t=start->data;
	node*p=start;
	start=start->next;
	delete p;
	return t;
}

void merge(const int x,const int y)
{
	if(x==y)return;
	int i;
	d[x]+=d[y];d[y]=0;
	while(c[y]){
		i=pop(c[y]);
		b[i]=x;
		push(c[x],i);
	}
}

void step2(void)
{
	int i;
	for(i=1;i<n;i++)
		if(a[i].y==a[i-1].y&&a[i].x==a[i-1].x+1)
			merge(b[a[i].id],b[a[i-1].id]);
}

int max=0;

void print(void)
{
	FILE*fout=fopen("banana.out","wt");
	fprintf(fout,"%d",max);
	fclose(fout);
}

void qsort1(const int l,const int r)
{
	int i,j;
	tree x,y;
	i=l;j=r;
	x=a[(l+r)/2];
	do{
		while(cmp1(a[i],x)==-1)i++;
		while(cmp1(x,a[j])==-1)j--;
		if(i<=j){
			y=a[i];a[i]=a[j];a[j]=y;
			i=i+1;j=j-1;
		}
	}while(i<=j);
  if(l<j)qsort1(l,j);
  if(i<r)qsort1(i,r);
}
void qsort2(const int l,const int r)
{
	int i,j;
	tree x,y;
	i=l;j=r;
	x=a[(l+r)/2];
	do{
		while(cmp2(a[i],x)==-1)i++;
		while(cmp2(x,a[j])==-1)j--;
		if(i<=j){
			y=a[i];a[i]=a[j];a[j]=y;
			i=i+1;j=j-1;
		}
	}while(i<=j);
  if(l<j)qsort2(l,j);
  if(i<r)qsort2(i,r);
}
void qsort3(const int l,const int r)
{
	int i,j;
	int x,y;
	i=l;j=r;
	x=d[(l+r)/2];
	do{
		while(cmp3(d[i],x)==-1)i++;
		while(cmp3(x,d[j])==-1)j--;
		if(i<=j){
			y=d[i];d[i]=d[j];d[j]=y;
			i=i+1;j=j-1;
		}
	}while(i<=j);
  if(l<j)qsort3(l,j);
  if(i<r)qsort3(i,r);
}

int main(void)
{
	read();
	qsort1(0,n-1);
	step1();
	qsort2(0,n-1);
	step2();
	qsort3(0,n-1);
	for(int i=0;i<k;i++)max+=d[i];
	print();
	return 0;
}