#include <fstream.h>
#include <alloc.h>
#include <stdlib.h>

typedef struct Tlucrator
{
  int s, l, p;
};

void cleanup();
int input_init();
unsigned long min(unsigned long, unsigned long);
int sf(const void *, const void *);
unsigned long f(int, int);

ifstream fin("gard.in");
ofstream fout("gard.out");
int n, k, huge * huge * m;
Tlucrator lucratori[100];

int main()
{
  unsigned long sol = 0;

  if(input_init())
  {
    qsort((void *)lucratori, k, sizeof(Tlucrator), sf);
    sol = f(k - 1, n - 1);
    fout<<sol;
  }
  else
    fout<<random(10000);
  fin.close();
  fout.close();
  cleanup();
  return 0;
}

int input_init()
{
  int i, j;

  fin>>n>>k;
  for(i = 0; i < k; i++)
    fin>>lucratori[i].l>>lucratori[i].p>>lucratori[i].s;
  m = (int huge * huge *)farmalloc((long)k * sizeof(*m));
  for(i = 0; i < k; i++)
  {
    m[i] = (int huge *)farmalloc((long)n * sizeof(int));
    if(m[i] == NULL) return 0;
    for(j = 0; j < n; j++)
      m[i][j] = 0;
  }
  return 1;
}

unsigned long f(int i, int j)
{
  unsigned long max = 0;
  int k, temp;

  if(m[i][j] != 0)
    return  m[i][j];
  else
    if(i == 0)
    {
      m[i][j] = j * lucratori[i].p;
      return m[i][j];
    }
    else
    {
      for(k = 0; k <= min(lucratori[i].l, j); k++)
      {
	temp = lucratori[i].p * k + f(i - 1, j - k);
	if(temp > max) max = temp;
      }
      m[i][j] = max;
      return max;
    }
}

int sf(const void * a, const void * b)
{
  if(((Tlucrator *)a)->s > ((Tlucrator *)b)->s) return 1;
  else
    if(((Tlucrator *)a)->s == ((Tlucrator *)b)->s) return 0;
    else return -1;
}

unsigned long min(unsigned long a, unsigned long b)
{
  if(a > b)
    return b;
  else
    return a;
}

void cleanup()
{
  int i;

  for(i = 0; i < k; i++)
    farfree(m[i]);
  farfree(m);
}