
// Baraj pentru lotul national de informatica, aprilie 2002
// Ziua 2

// Flaviu Pasca, Bistrita-Nasaud
// ID: P2C13

// Problema: Banana

#pragma option -r -G -O2 -mh
#include <stdio.h>
#include <stdlib.h>

#define ABS(v)     ((v>0)? (v):(-(v)))
#define CON(z1,z2) (ABS(z1.x-z2.x)+ABS(z1.y-z2.y)==1)

typedef struct{
	int x,y;
}bn;

FILE *f=NULL;
bn b[16000]={0};
int i=0,j=0,n=0,k=0;
int huge p[16000]={0};
int huge rg[16000]={0};
int huge xl[16000]={0};
int huge xp[10003]={0};
int u=0,v=0,ret=0,ps=0;
int fc(const void*,const void*);
int bin(int,int,int);
int getset(int);
void reun(int,int);
void main()
{
	f=fopen("BANANA.in","rt");
	fscanf(f,"%d %d",&n,&k);
	for(i=0;i<n;i++)  { p[i]=i; fscanf(f,"%d %d",&(b[i].x),&(b[i].y)); }
	fclose(f);
	if(n==1) { f=fopen("BANANA.out","wt"); fprintf(f,"1"); fclose(f); return; }
	qsort(b,n,sizeof(bn),fc);
	for(i=n-1;i>=0;i--) xl[b[i].x]=i+1,++xp[b[i].x];
	for(i=0;i<n;i++)
	{
		j=-1;
		if(xl[b[i].x-1]) j=bin(i,xl[b[i].x-1]-1,xl[b[i].x]-2);
		if(j<0) j=bin(i,xl[b[i].x]-1,xl[b[i].x]+xp[b[i].x]-2);
		if(j<0 && xp[b[i].x+1])
			j=bin(i,xl[b[i].x+1]-1,xl[b[i].x+1]+xp[b[i].x+1]-2);

		if(j>=0)
		{
			u=getset(i),v=getset(j);
			if(u!=v) reun(u,v);
		}
	}
	for(i=0;i<n;i++) b[i].x=b[i].y=0;
	for(i=0;i<n;i++) { u=getset(i); ++b[u].x; }
	qsort(b,n,sizeof(bn),fc);
	for(i=u=0;i<k;i++) u+=b[n-i-1].x;
	f=fopen("BANANA.out","wt");
	fprintf(f,"%d",u);
	fclose(f);
}
int fc(const void* v1,const void* v2)
{
	bn x1=*((bn*)v1),x2=*((bn*)v2);
	if(x1.x<x2.x) return -1;
	else if(x1.x>x2.x) return 1;
	else if(x1.y<x2.y) return -1;
	else if(x1.y>x2.y) return 1;
	return 0;
}
int bin(int vx,int r,int q)
{
	ret=-1;
	while(1)
	{
		if(r<0 || q>n-1) break;
		if(r<q-1)
		{
			ps=(r+q)/2;
			if(CON(b[vx],b[ps]) && getset(vx)!=getset(ps)) { ret=ps; break; }
			if(b[ps].y-b[vx].y>1) q=ps-1;
			else if(b[ps].y-b[vx].y<-1) r=ps+1;
			else
			{
				if(CON(b[vx],b[r]) && getset(vx)!=getset(r)) { ret=r; break; }
					 else ++r;
				if(CON(b[vx],b[q]) && getset(vx)!=getset(q)) { ret=q; break; }
					 else --q;
			}
		}
		else if(CON(b[vx],b[r]) && getset(vx)!=getset(r)) { ret=r; break; }
		else if(CON(b[vx],b[q]) && getset(vx)!=getset(q)) { ret=q; break; }
		else break;
	}
	return ret;
}
int getset(int x)
{
	if(p[x]!=x) p[x]=getset(p[x]);
	return p[x];
}
void reun(int x,int y)
{
	if(x!=y)
		if(rg[x]>rg[y])	p[y]=x;
		else
		{
			p[x]=y;
			if(rg[x]==rg[y]) ++rg[y];
		}
}