{$A+,B-,D+,E+,F-,G-,I-,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 65520,0,655360}
Program Banana;

const MaxB=16001;

type bananier=record
       x,y:integer;
     end;
     blist=array[1..MaxB] of bananier;
     clist=array[1..MaxB] of integer;

var nrv,nc,nr,k,piv_,tmp_:integer;
    b:^blist;
    bc,c:^clist;
    piv,tmp:bananier;

  Procedure Load;
  var f:text;
      x,y,i:integer;
  begin
    assign(f,'banana.in');
    reset(f);
    readln(f,nr,k);
    new(b);
    for i:=1 to nr do
      readln(f,b^[i].x,b^[i].y);
    close(f);
  end;

  Procedure Sort(s,e:integer);
  var i,j:integer;
  begin
    i:=s;
    j:=e;
    piv:=b^[(i+j) div 2];
    repeat
    while (b^[i].x<piv.x)or((b^[i].x=piv.x)and(b^[i].y<piv.y))do inc(i);
    while (b^[j].x>piv.x)or((b^[j].x=piv.x)and(b^[j].y>piv.y))do dec(j);
    if i<=j then begin
      tmp:=b^[i];
      b^[i]:=b^[j];
      b^[j]:=tmp;
      inc(i);dec(j);
    end;
    until i>j;
    if i<e then Sort(i,e);
    if s<j then Sort(s,j);
  end;

  Function Pozitie(t1,t2:bananier):integer;
  begin
    if (t1.x=t2.x)and(t1.y=t2.y)then Pozitie:=0 else
      if (t1.x>t2.x)or((t1.x=t2.x)and(t1.y>t2.y)) then
        Pozitie:=1 else Pozitie:=-1;
  end;

  Function SF(p:bananier):integer;
  var v,i,j,w:integer;
  begin
    if (p.x<1) or (p.y<1) then begin
      SF:=-1;exit;
    end;
    if nr=1 then begin
      if (b^[1].x=p.x)and(b^[1].y=p.y) then SF:=1 else SF:=-1;
      exit;
    end;
    i:=1;
    j:=nr;
    repeat
      if j-1=i then begin
        if Pozitie(p,b^[i])=0 then SF:=i else
          if Pozitie(p,b^[j])=0 then SF:=j else
            SF:=-1;
        exit;
      end;
      w:=(i+j) div 2;
      v:=Pozitie(p,b^[w]);
      if v=0 then begin
        SF:=w;exit;
      end;
      if v=-1 then j:=w else i:=w;
    until false;
  end;

  Procedure Visit(ban:integer);
  var coada:^clist;
      q,x,y:integer;
  begin
    c^[ban]:=nc;
    x:=1;
    y:=1;
    new(coada);
    coada^[1]:=ban;
    while x<=y do begin
      tmp:=b^[coada^[x]];
      inc(tmp.x);
      q:=SF(tmp);
      if q>0 then
        if c^[q]=0 then begin
          inc(y);
          coada^[y]:=q;
          c^[q]:=nc;
        end;
      tmp.x:=tmp.x-2;
      q:=SF(tmp);
      if q>0 then
        if c^[q]=0 then begin
          inc(y);
          coada^[y]:=q;
          c^[q]:=nc;
        end;
      inc(tmp.x);
      inc(tmp.y);
      q:=SF(tmp);
      if q>0 then
        if c^[q]=0 then begin
          inc(y);
          coada^[y]:=q;
          c^[q]:=nc;
        end;
      tmp.y:=tmp.y-2;
      q:=SF(tmp);
      if q>0 then
        if c^[q]=0 then begin
          inc(y);
          coada^[y]:=q;
          c^[q]:=nc;
        end;
      inc(x);
    end;
    dispose(coada);
    nrv:=y;
  end;

  Procedure Conex;
  var i:integer;
  begin
    new(c);
    new(bc);
    fillchar(c^,sizeof(c^),0);
    nc:=0;
    for i:=1 to nr do
      if c^[i]=0 then begin
        inc(nc);
        nrv:=0;
        Visit(i);
        bc^[nc]:=nrv;
      end;
  end;

  Procedure SortBC(s,e:integer);
  var i,j:integer;
  begin
    i:=s;
    j:=e;
    piv_:=bc^[(i+j)div 2];
    repeat
    while piv_<bc^[i] do inc(i);
    while piv_>bc^[j] do dec(j);
    if i<=j then begin
      tmp_:=bc^[i];
      bc^[i]:=bc^[j];
      bc^[j]:=tmp_;
      inc(i);
      dec(j);
    end;
    until i>j;
    if s<j then SortBC(s,j);
    if i<e then SortBC(i,e);
  end;

  Procedure Solutie;
  var f:text;
      w,i:integer;
      r:longint;
  begin
    w:=k;
    if w>nc then w:=nc;
    r:=0;
    for i:=1 to w do
      r:=r+bc^[i];
    assign(f,'banana.out');
    rewrite(f);
    writeln(f,r);
    close(f);
  end;

Begin

  Load;
  Sort(1,nr);
  Conex;
  SortBC(1,nc);
  Solutie;

End.