#include <fstream.h>
#include <stdlib.h>

#define max(a, b) (((a) > (b)) ? (a) : (b))
#define min(a, b) (((a) < (b)) ? (a) : (b))

#define INF		"gard.in"
#define OUTF	"gard.out"
#define MAXN	16001
#define MAXM	101

typedef struct tagM {
	int l, p, s;
} MUNC, *PMUNC;

int n, k;
MUNC m[MAXM];
char v[MAXN];

unsigned long s, smax, t;

int sort_fn1(const void *a, const void *b)
{
	PMUNC m1, m2;
	m1 = (PMUNC)a;
	m2 = (PMUNC)b;
	if (m1->l > m2->l) return 1;
	return -1;
}

int sort_fn2(const void *a, const void *b)
{
	PMUNC m1, m2;
	m1 = (PMUNC)a;
	m2 = (PMUNC)b;
	if (m1->s > m2->s) return -1;
	return 1;
}

int sort_fn3(const void *a, const void *b)
{
	PMUNC m1, m2;
	m1 = (PMUNC)a;
	m2 = (PMUNC)b;
	if (m1->p > m2->p) return -1;
	return 1;
}

void readin()
{
	ifstream inf(INF);
	inf >> n >> k;
	for (int i = 1; i <= k; i++)
		inf >> m[i].l >> m[i].p >> m[i].s;
}

void solve()
{
	int en;
	s = 0;
	memset(&v[1], 0, n);
	for (int i = 1; i <= k; i++) {
		t = 0;
		for (int j = m[i].l; j >= max(m[i].l-m[i].s+1, 1); j--) if (v[j]) break;
		if (j == m[i].l) continue;
		j++;
		en = min(m[i].l + j, n);
		for (;j <= en; j++) {
			if (v[j]) break;
			v[j] = 1;
			t++;
		}
		s += t*m[i].p;
	}
	if (s > smax) smax = s;
}

void writeout()
{
	ofstream outf(OUTF);
	outf << smax;
}

int main()
{
	readin();
	qsort(&m[1], k, sizeof(m[0]), sort_fn1);
	solve();
	qsort(&m[1], k, sizeof(m[0]), sort_fn2);
	solve();
	qsort(&m[1], k, sizeof(m[0]), sort_fn3);
	solve();
	writeout();
	return 0;
}