{$A+,B-,D+,E+,F-,G-,I-,L+,N-,O-,P-,Q+,R-,S-,T-,V+,X+,Y+}
{$M 16384,0,655360}
const
  nin='banana.in';
  nout='banana.out';
  MaxNr=16000;
type
  point=record
    x,y:word;
  end;
  pvect=array[1..MaxNr] of point;
  vect=array[1..MaxNr] of word;
var
  answer:word;
  nr,k:word;
  p:^pvect;
  idx,father:vect;
  ban,banzon:^vect;

procedure readdata;
var
  fi:text;
  i:word;
begin
  assign(fi,nin);
  reset(fi);
  read(fi,nr,k);
  for i:=1 to nr do
    read(fi,p^[i].x,p^[i].y);
  close(fi);
end;

procedure writesol;
var
  fo:text;
begin
  assign(fo,nout);
  rewrite(fo);
  write(fo,answer);
  close(fo);
end;

function gteqline(var p1,p2:point):boolean;
begin
  if p1.x>p2.x then gteqline:=true
  else if p1.x<p2.x then gteqline:=false
  else if p1.y>=p2.y then gteqline:=true
  else gteqline:=false
end;

function partline(left,right:word):word;
var
  i,j,tmpf:word;
  tmp,piv:point;
begin
  i:=left-1;
  j:=right+1;
  piv:=p^[left];
  repeat
    repeat inc(i); until gteqline(p^[i],piv);
    repeat dec(j); until gteqline(piv,p^[j]);
    if i<j then
      begin
        tmp:=p^[i];
        p^[i]:=p^[j];
        p^[j]:=tmp;
        tmpf:=idx[i];
        idx[i]:=idx[j];
        idx[j]:=tmpf;
      end;
  until i>=j;
  partline:=j;
end;

procedure qsortline(left,right:word);
var
  m:word;
begin
  if left<right then
    begin
      m:=partline(left,right);
      qsortline(left,m);
      qsortline(m+1,right);
    end;
end;

function gteqcol(var p1,p2:point):boolean;
begin
  if p1.y>p2.y then gteqcol:=true
  else if p1.y<p2.y then gteqcol:=false
  else if p1.x>=p2.x then gteqcol:=true
  else gteqcol:=false
end;

function partcol(left,right:word):word;
var
  i,j,tmpf:word;
  tmp,piv:point;
begin
  i:=left-1;
  j:=right+1;
  piv:=p^[left];
  repeat
    repeat inc(i); until gteqcol(p^[i],piv);
    repeat dec(j); until gteqcol(piv,p^[j]);
    if i<j then
      begin
        tmp:=p^[i];
        p^[i]:=p^[j];
        p^[j]:=tmp;
        tmpf:=idx[i];
        idx[i]:=idx[j];
        idx[j]:=tmpf;
      end;
  until i>=j;
  partcol:=j;
end;

procedure qsortcol(left,right:word);
var
  m:word;
begin
  if left<right then
    begin
      m:=partcol(left,right);
      qsortcol(left,m);
      qsortcol(m+1,right);
    end;
end;

procedure init;
var
  i:word;
begin
  for i:=1 to nr do
    begin
      father[i]:=i;
      idx[i]:=i;
    end;
end;

function find(i:word):word;
begin
  if father[i]=i then find:=i
  else
    begin
      father[i]:=find(father[i]);
      find:=father[i];
    end;
end;

procedure union(i,j:word);
begin
  father[find(i)]:=find(father[j]);
end;

procedure conectline;
var
  i:word;
begin
  i:=1;
  repeat
    inc(i);
    while (i<=nr) and (p^[i].x=p^[i-1].x) do
      begin
        if p^[i].y-1=p^[i-1].y then
          union(idx[i],idx[i-1]);
        inc(i);
      end;
  until i>=nr;
end;

procedure conectcol;
var
  i:word;
begin
  i:=1;
  repeat
    inc(i);
    while (i<=nr) and (p^[i].y=p^[i-1].y) do
      begin
        if p^[i].x-1=p^[i-1].x then
          union(idx[i],idx[i-1]);
        inc(i);
      end;
  until i>=nr;
end;

procedure findsol;
var
  i,tmp,left:word;
begin
  fillchar(ban^,sizeof(ban^),0);
  fillchar(banzon^,sizeof(banzon^),0);
  for i:=1 to nr do
    begin
      if father[father[i]]<>father[i] then tmp:=find(i);
      inc(ban^[father[i]]);
    end;
  for i:=1 to nr do
    if ban^[i]<>0 then inc(banzon^[ban^[i]]);
  answer:=0;
  left:=k;
  for i:=nr downto 1 do
    if banzon^[i]>0 then
      if left>=banzon^[i] then
        begin
          answer:=answer+i*banzon^[i];
          left:=left-banzon^[i];
          if left=0 then exit;
        end
      else
        begin
          answer:=answer+left*i;
          exit;
        end;
end;

procedure solve;
begin
  init;
  qsortline(1,nr);
  conectline;
  qsortcol(1,nr);
  conectcol;
  findsol;
end;

begin
  new(p);
  new(ban);
  new(banzon);
  readdata;
  solve;
  writesol;
end.