#include <stdio.h>
#include <stdlib.h>

FILE *fin=fopen("banana.in","rt");
FILE *fout=fopen("banana.out","wt");

int nr,k,xi,yi;
long suma;
int huge palm[16001][2];
int huge sortx[16001][3]; // 0=x, 1=y
int huge sorty[16001][3];

int huge tata[16001];
int huge adanc[16001];
int huge dim[16001];



int  root(int);
void uneste(int,int);
int  qposx(int,int);
int  qposy(int,int);
int  qposdim(int,int);
void qsortx(int,int);
void qsorty(int,int);
void qsortdim(int,int);
int  bsearchx(int,int,int,int);
int  bsearchy(int,int,int,int);


int main()
{

    int i,j,vecin,tatanod,tatavec;


    fscanf(fin,"%d %d",&nr,&k);
    for (i=1;i<=nr;i++)
    {
	fscanf(fin,"%d %d",&xi,&yi);
	sortx[i][0]=sorty[i][0]=xi;
	sortx[i][1]=sorty[i][1]=yi;
	sortx[i][2]=sorty[i][2]=i;
	palm[i][0]=xi;
	palm[i][1]=yi;
    }

    qsortx(1,nr);
    qsorty(1,nr);

    for (i=1;i<=nr;i++)
    {
	tata[i]=i;
	adanc[i]=1;
	dim[i]=1;
    }



    for (i=1;i<=nr;i++)
    {
	  vecin=0;
	  if ((palm[i][1]-1)>0)
		 vecin=bsearchx(1,nr,palm[i][0],palm[i][1]-1);
	  if (vecin>0) uneste(i,vecin);

	  if ((palm[i][1]+1)<=10000)
		 vecin=bsearchx(1,nr,palm[i][0],palm[i][1]+1);
	  if (vecin>0) uneste(i,vecin);

	  if ((palm[i][0]-1)>0)
		vecin=bsearchy(1,nr,palm[i][0]-1,palm[i][1]);
	  if (vecin>0) uneste(i,vecin);

	  if ((palm[i][0]+1)<=10000)
		vecin=bsearchy(1,nr,palm[i][0]+1,palm[i][1]);
	  if (vecin>0) uneste(i,vecin);
    }

    qsortdim(1,nr);

    suma=0;
    for (i=1;i<=k;i++)
	suma+=dim[i];

    fprintf(fout,"%ld\n",suma);

    return(0);
}



int root(int nod)
{
   int tmp,varf;


   tmp=nod;
   while ( tata[nod]!=nod) nod=tata[nod];

   varf=nod;
   nod=tmp;
   while ( tata[nod]!=nod )
   {

       tmp=tata[nod];
       tata[nod]=varf;
       nod=tmp;
   }

   return(varf);
}


void uneste(int nod1,int nod2)
{
    int tatanod, tatavec;

    tatanod=root(nod1);
    tatavec=root(nod2);
    if (tatanod==tatavec) return;

    nod1=tatanod;
    nod2=tatavec;

   if (adanc[nod1]==adanc[nod2])
   {
	adanc[nod1]++;
	tata[nod2]=nod1;

	dim[nod1]+=dim[nod2];
	dim[nod2]=0;
	return;
   }

   if (adanc[nod1]>adanc[nod2])
   {
	tata[nod2]=nod1;

	dim[nod1]+=dim[nod2];
	dim[nod2]=0;
   }
   else
   {
	tata[nod1]=nod2;

	dim[nod2]+=dim[nod1];
	dim[nod1]=0;
   }

   return;
}



int bsearchx(int li, int ls,int x,int y)
{
   int juma;


   if (li==ls)
   {
	if ((sortx[li][0]==x)&&(sortx[li][1]==y)) return(sortx[li][2]);
	return(0);
   }

   juma=(li+ls)/2;
   if ((sortx[juma][0]==x)&&(sortx[juma][1]==y)) return(sortx[juma][2]);

   if (x>sortx[juma][0])
   {
	 if (juma<ls) return(bsearchx(juma+1,ls,x,y));
		 else return(0);
   }

   if (x<sortx[juma][0])
   {
	 if (juma>li) return(bsearchx(li,juma-1,x,y));
		 else return(0);
   }


   if (y>sortx[juma][1])
   {
	 if (juma<ls) return(bsearchx(juma+1,ls,x,y));
		 else return(0);
   }

   if (y<sortx[juma][1])
   {
	 if (juma>li) return(bsearchx(li,juma-1,x,y));
		 else return(0);
   }

   return(0);
}


int bsearchy(int li, int ls,int x,int y)
{
   int juma;


   if (li==ls)
   {
	if ((sorty[li][0]==x)&&(sorty[li][1]==y)) return(sorty[li][2]);
	return(0);
   }

   juma=(li+ls)/2;
   if ((sorty[juma][0]==x)&&(sorty[juma][1]==y)) return(sorty[juma][2]);


   if (y>sorty[juma][1])
   {
	 if (juma<ls) return(bsearchy(juma+1,ls,x,y));
		 else return(0);
   }

   if (y<sorty[juma][1])
   {
	 if (juma>li) return(bsearchy(li,juma-1,x,y));
		 else return(0);
   }


   if (x>sorty[juma][0])
   {
	 if (juma<ls) return(bsearchy(juma+1,ls,x,y));
		 else return(0);
   }

   if (x<sorty[juma][0])
   {
	 if (juma>li) return(bsearchy(li,juma-1,x,y));
		 else return(0);
   }


   return(0);
}




int qposdim(int li, int ls)
{
   int tmp,pi,pj;

   pi=1;
   pj=0;
   while (li<ls)
   {
	if (dim[li]<dim[ls])
	{
	       tmp=dim[li]; dim[li]=dim[ls]; dim[ls]=tmp;
	       pi=!pi;
	       pj=!pj;
	}
	li+=pi;
	ls-=pj;
   }
   return(li);
}


void qsortdim(int li, int ls)
{
    int pos;

    pos=qposdim(li,ls);
    if (pos>(li+1)) qsortdim(li,pos-1);
    if (pos<(ls-1)) qsortdim(pos+1,ls);
}



int qposx(int li, int ls)
{
   int tmp,pi,pj;

   pi=1;
   pj=0;
   while (li<ls)
   {
	if ((sortx[li][0]>sortx[ls][0])||( (sortx[li][0]==sortx[ls][0])&&(sortx[li][1]>sortx[ls][1])  ))
	{
	       tmp=sortx[li][0]; sortx[li][0]=sortx[ls][0]; sortx[ls][0]=tmp;
	       tmp=sortx[li][1]; sortx[li][1]=sortx[ls][1]; sortx[ls][1]=tmp;
	       tmp=sortx[li][2]; sortx[li][2]=sortx[ls][2]; sortx[ls][2]=tmp;
	       pi=!pi;
	       pj=!pj;
	}
	li+=pi;
	ls-=pj;
   }
   return(li);
}

int qposy(int li, int ls)
{
   int tmp,pi,pj;

   pi=1;
   pj=0;
   while (li<ls)
   {
	if ((sorty[li][1]>sorty[ls][1])||( (sorty[li][1]==sorty[ls][1])&&(sorty[li][0]>sorty[ls][0]) ))
	{
	       tmp=sorty[li][0]; sorty[li][0]=sorty[ls][0]; sorty[ls][0]=tmp;
	       tmp=sorty[li][1]; sorty[li][1]=sorty[ls][1]; sorty[ls][1]=tmp;
	       tmp=sorty[li][2]; sorty[li][2]=sorty[ls][2]; sorty[ls][2]=tmp;
	       pi=!pi;
	       pj=!pj;
	}
	li+=pi;
	ls-=pj;
   }
   return(li);
}


void qsortx(int li, int ls)
{
    int pos;

    pos=qposx(li,ls);
    if (pos>(li+1)) qsortx(li,pos-1);
    if (pos<(ls-1)) qsortx(pos+1,ls);
}


void qsorty(int li, int ls)
{
    int pos;

    pos=qposy(li,ls);
    if (pos>(li+1)) qsorty(li,pos-1);
    if (pos<(ls-1)) qsorty(pos+1,ls);
}
