{ Mugurel Ionut Andreica - Bucuresti, ROMANIA }

{$S-,I-,R-,Q-,N+}
{$M 15000,0,655360}
Program ARBORE;

const filein='ARBORE.IN';
      fileout='ARBORE.OUT';
      MAXN=100;
      MARE=10000;

type plist=^list;
     list=record
           fiu:longint;
           urm:plist;
          end;

var min:array[1..MAXN,0..1] of longint;
    next:array[1..MAXN] of plist;
    deg,tata,nfii:array[1..MAXN] of longint;
    muc:array[1..MAXN,1..2] of longint;
    i,j,k,m,n,r,sum,nodstart,f1,f2:longint;
    aux,aa1,aa2:plist;

procedure maketree(nod:longint);
var aa:plist;
begin
aa:=next[nod];
while (aa<>nil) do
  begin
    if ((tata[aa^.fiu]=0) and (aa^.fiu<>tata[nod])) then
      begin
        inc(nfii[nod]);
        tata[aa^.fiu]:=nod;
        maketree(aa^.fiu);
      end;
    aa:=aa^.urm;
  end;
end;

procedure df(nod:longint);
var aa:plist;
begin
sum:=sum+min[nod,0];

if (tata[nod]<>nodstart) and ((sum+1)<min[nodstart,1]) then
  begin
    min[nodstart,1]:=sum+1;
    muc[nodstart,1]:=nodstart;
    muc[nodstart,2]:=nod;
  end;

aa:=next[nod];
while (aa<>nil) do
  begin
    if (aa^.fiu<>tata[nod]) then
      begin
        sum:=sum-min[aa^.fiu,1];
        df(aa^.fiu);
        sum:=sum+min[aa^.fiu,1];
      end;

    aa:=aa^.urm;
  end;

sum:=sum-min[nod,0];
end;

procedure go2(nod:longint);
var aa:plist;
begin
sum:=sum+min[nod,0];

if ((sum+1)<min[nodstart,1]) then
  begin
    min[nodstart,1]:=sum+1;
    muc[nodstart,1]:=f1;
    muc[nodstart,2]:=nod;
  end;

aa:=next[nod];
while (aa<>nil) do
  begin
    if (aa^.fiu<>tata[nod]) then
      begin
        sum:=sum-min[aa^.fiu,1];

        go2(aa^.fiu);

        sum:=sum+min[aa^.fiu,1];
      end;

    aa:=aa^.urm;
  end;

sum:=sum-min[nod,0];
end;

procedure go1(nod:longint);
var aa:plist;
begin
sum:=sum+min[nod,0];

go2(f2);

aa:=next[nod];
while (aa<>nil) do
  begin
    if (aa^.fiu<>tata[nod]) then
      begin
        sum:=sum-min[aa^.fiu,1];

        f1:=aa^.fiu;
        go1(f1);

        sum:=sum+min[aa^.fiu,1];
      end;

    aa:=aa^.urm;
  end;

sum:=sum-min[nod,0];
end;

procedure compute(nod:longint);
var aa:plist;
    summ:longint;
begin
if (deg[nod]=1) then
  begin
    min[nod,0]:=0;
    min[nod,1]:=MARE;
  end
else
  begin
    summ:=0;
    aa:=next[nod];

    while (aa<>nil) do
      begin
        if (aa^.fiu<>tata[nod]) then
          begin
            compute(aa^.fiu);
            summ:=summ+min[aa^.fiu,1];
          end;
        aa:=aa^.urm;
      end;

    min[nod,0]:=summ;
    min[nod,1]:=MARE;

    { caz 1: se uneste nod cu unul din nodurile din subarborele sau }
    nodstart:=nod;
    sum:=min[nod,0];

    aa:=next[nod];
    while (aa<>nil) do
      begin
        if (aa^.fiu<>tata[nod]) then
          begin
            sum:=sum-min[aa^.fiu,1];
            df(aa^.fiu);
            sum:=sum+min[aa^.fiu,1];
          end;
        aa:=aa^.urm;
      end;

    { caz 2: se unesc 2 noduri din subarborele lui nod }
    nodstart:=nod;
    sum:=min[nod,0];

    aa1:=next[nod];
    while (aa1<>nil) do
      begin
        if (aa1^.fiu<>tata[nod]) then
          begin
            sum:=sum-min[aa1^.fiu,1];

            aa2:=aa1^.urm;
            while (aa2<>nil) do
              begin
                if (aa2^.fiu<>tata[nod]) then
                  begin
                    sum:=sum-min[aa2^.fiu,1];
                    f2:=aa2^.fiu;
                    f1:=aa1^.fiu;

                    go1(f1);

                    sum:=sum+min[aa2^.fiu,1];
                  end;

                aa2:=aa2^.urm;
              end;

            sum:=sum+min[aa1^.fiu,1];
          end;

        aa1:=aa1^.urm;
      end;
  end;
end;

procedure build(nod:longint);
var aa:plist;
    i,j,f1,f2,lf1,lf2:longint;
begin
i:=muc[nod,1];
j:=muc[nod,2];
writeln(i,' ',j);

f2:=j; lf2:=0;
while (tata[f2]<>nod) do
  begin
    aa:=next[f2];
    while (aa<>nil) do
      begin
        if (aa^.fiu<>tata[f2]) and (aa^.fiu<>lf2) then
          build(aa^.fiu);

        aa:=aa^.urm;
      end;

    lf2:=f2;
    f2:=tata[f2];
  end;

aa:=next[f2];
while (aa<>nil) do
  begin
    if (aa^.fiu<>tata[f2]) and (aa^.fiu<>lf2) then
      build(aa^.fiu);

    aa:=aa^.urm;
  end;

if (i<>nod) then
  begin
    f1:=i; lf1:=0;
    while (tata[f1]<>nod) do
      begin
        aa:=next[f1];
        while (aa<>nil) do
          begin
            if (aa^.fiu<>tata[f1]) and (aa^.fiu<>lf1) then
              build(aa^.fiu);

            aa:=aa^.urm;
          end;

        lf1:=f1;
        f1:=tata[f1];
      end;

    aa:=next[f1];
    while (aa<>nil) do
      begin
        if (aa^.fiu<>tata[f1]) and (aa^.fiu<>lf1) then
          build(aa^.fiu);

        aa:=aa^.urm;
      end;
  end
else
  begin
    f1:=i;
  end;

aa:=next[nod];
while (aa<>nil) do
  begin
    if (aa^.fiu<>tata[nod]) and (aa^.fiu<>f1) and (aa^.fiu<>f2) then
      build(aa^.fiu);

    aa:=aa^.urm;
  end;
end;

begin
assign(input,filein);
reset(input);
readln(n);

fillchar(deg,sizeof(deg),0);
fillchar(next,sizeof(next),0);
for k:=1 to n-1 do
  begin
    readln(i,j);
    inc(deg[i]);
    inc(deg[j]);

    new(aux);
    aux^.fiu:=i;
    aux^.urm:=next[j];
    next[j]:=aux;

    new(aux);
    aux^.fiu:=j;
    aux^.urm:=next[i];
    next[i]:=aux;
  end;
close(input);

for i:=1 to n do
  if (deg[i]>1) then
    begin
      r:=i;
      break;
    end;

fillchar(tata,sizeof(tata),0);
fillchar(nfii,sizeof(nfii),0);
maketree(r);

fillchar(muc,sizeof(muc),0);
compute(r);

assign(output,fileout);
rewrite(output);

if (min[r,1]>=MARE) then
  writeln(-1)
else
  begin
    writeln(min[r,1]);
    build(r);
  end;
close(output);
end.