{$N+,S-,R-,Q-}
{$M 15000,0,655360}
Program COMITAT;

const filein='comitat.in';
      fileout='comitat.out';
      MAXN=51;
      MARE=1001;
      eps:double=1e-8;

type linie=array[0..MAXN] of integer;
     plinie=^linie;
     lin2=array[0..MAXN] of byte;
     plin2=^lin2;

var fin,fout:text;
    lmin:array[0..MAXN,0..MAXN] of plinie;
    pred:array[0..MAXN,0..MAXN] of plin2;
    x,y,ind:array[0..MAXN] of longint;
    ung:array[0..MAXN] of double;
    i,j,ii,jj,k,kk,n,p,pp,l,plus,a,b,c,max,li,lj:longint;
    ok:boolean;

begin
assign(fin,filein);
reset(fin);
readln(fin,n);
for i:=1 to n do
  begin
    readln(fin,x[i],y[i]);
    ind[i]:=i;
  end;
readln(fin,l);
close(fin);

x[0]:=0;
y[0]:=0;
ind[0]:=0;

for i:=1 to n do
  begin
    if (x[i]=0) then
      ung[i]:=pi/2
    else
      ung[i]:=arctan(y[i]/x[i]);
  end;

for i:=0 to n-1 do
  for j:=i+1 to n do
    if (ung[ind[i]]>ung[ind[j]]) or
       ((abs(ung[ind[i]]-ung[ind[j]])<eps) and
       ((y[ind[i]]<y[ind[j]]) or (x[ind[i]]<x[ind[j]]))) then
      begin
        k:=ind[i];
        ind[i]:=ind[j];
        ind[j]:=k;
      end;

for i:=0 to n do
  for j:=0 to n do
    begin
      new(lmin[i,j]);
      for k:=0 to n+1 do
        lmin[i,j]^[k]:=MARE;

      new(pred[i,j]);
      fillchar(pred[i,j]^,sizeof(linie),0);
    end;

p:=-1;
repeat
inc(p);
pp:=p;

while (abs(ung[ind[pp]]-ung[ind[p]])<eps) and (pp<n) do
  inc(pp);

if (abs(ung[ind[pp]]-ung[ind[p]])>eps) then
  dec(pp);

if (pp-p>0) then
  begin
    i:=ind[pp];
    j:=ind[pp-1];

    if (i<>0) then
      plus:=1
    else
      plus:=0;

    lmin[j,i]^[2+plus]:=abs(x[i]-x[j])+abs(y[i]-y[j])+
                        abs(x[i]-x[0])+abs(y[i]-y[0]);
    pred[j,i]^[2+plus]:=0;

    for ii:=pp-2 downto p do
      begin
        i:=ind[ii+1];
        j:=ind[ii];

        lmin[j,i]^[pp-ii+1+plus]:=lmin[i,ind[ii+2]]^[pp-ii+plus]+
                             abs(x[i]-x[j])+abs(y[i]-y[j]);
        pred[j,i]^[pp-ii+1+plus]:=ind[ii+2];
      end;
  end;

p:=pp;
until (p=n);

for i:=1 to n do
  lmin[i,0]^[2]:=x[i]+y[i];

for ii:=1 to n do
  begin
    i:=ind[ii];

    for jj:=0 to ii-1 do
      begin
        j:=ind[jj];
        for k:=3 to ii+1 do
          begin
            for pp:=0 to n do
              if (ind[pp]<>j) and (ind[pp]<>i) and
              (
              (abs(ung[ind[ii]]-ung[ind[jj]])>eps) or
              (

              (ung[ind[pp]]<ung[ind[jj]]) or
              (
              (pp<jj) and (pp<ii)
              )

              )
              )
              then
                begin
                  p:=ind[pp];

                  a:=y[p]-y[j];
                  b:=x[j]-x[p];
                  c:=x[p]*y[j]-x[j]*y[p];

                  plus:=lmin[j,p]^[k-1]+abs(x[i]-x[j])+abs(y[i]-y[j]);
                  if (a*x[i]+b*y[i]+c>=0) and (plus<lmin[i,j]^[k]) then
                    begin
                      lmin[i,j]^[k]:=plus;
                      pred[i,j]^[k]:=p;
                    end;
                end;
          end;
      end;
  end;

max:=0;
for ii:=0 to n do
  begin
    i:=ind[ii];
    for jj:=0 to n do
      if (ii<>jj) then
        begin
          j:=ind[jj];

          {
          a:=y[j]-y[i];
          b:=x[i]-x[j];
          }
          c:=x[j]*y[i]-x[i]*y[j];

          if (c>=0) then
            begin
              for k:=2 to n+1 do
                if (k>max) then
                  begin
                    plus:=lmin[i,j]^[k]+x[i]+y[i];

                    if (plus<=l) then
                      begin
                        max:=k;
                        li:=i;
                        lj:=j;
                      end;
                  end;
            end;
        end;
  end;

assign(fout,fileout);
rewrite(fout);
writeln(fout,max);

write(fout,li);
while (lj>0) do
  begin
    i:=pred[li,lj]^[max];
    li:=lj;
    lj:=i;
    max:=max-1;

    write(fout,' ',li);
  end;

writeln(fout);
close(fout);
end.