Program COMITAT_BACK;

const filein='comitat.in';
      fileout='comitat.out';
      MAXN=51;
      maxticks=17;

var x,y,sol,st:array[0..51] of integer;
    used:array[0..MAXN] of boolean;
    i,j,k,n,l,lmax,max:integer;

    t2:longint absolute 0:$046c;
    t1:longint;

procedure print;
begin
assign(output,fileout);
rewrite(output);
writeln(max);
for i:=1 to max-1 do
  write(sol[i],' ');
writeln;
close(output);
halt(0);
end;

function convex(p1,p2,p3:integer):boolean;
var a,b,c,rez:longint;
begin
a:=y[p1]-y[p2];
b:=x[p2]-x[p1];
c:=x[p1]*y[p2]-x[p2]*y[p1];

rez:=a*x[p3]+b*y[p3]+c;

if (rez>0) then
  convex:=true
else
if (rez<0) then
  convex:=false
else
  begin
    if (y[p2]=y[p1]) then
      begin
        if (abs(y[p3]-y[p2])<abs(y[p3]-y[p1])) and
           (abs(y[p3]-y[p1])>abs(y[p2]-y[p1])) then
          convex:=true
        else
          convex:=false;
      end
    else
      begin
        if (abs(x[p3]-x[p2])<abs(x[p3]-x[p1])) and
           (abs(x[p3]-x[p1])>abs(x[p2]-x[p1])) then
          convex:=true
        else
          convex:=false;
      end;
  end;
end;

function colin0(p1,p2:integer):boolean;
begin
colin0:=(x[p1]*y[p2]-x[p2]*y[p1]=0);
end;

procedure back(niv:integer);
var s:integer;
begin
if (t2-t1>maxticks) then
  print;

if (niv>max) and
   ( (convex(st[niv-2],st[niv-1],0)) or
     (colin0(st[niv-2],st[niv-1]))) and
   (l+x[st[niv-1]]+y[st[niv-1]]<=lmax)
then
  begin
    max:=niv;
    move(st,sol,sizeof(st));
  end;

for s:=1 to n do
  if (not used[s]) and (convex(st[niv-2],st[niv-1],s)) and
  ( (convex(st[niv-1],s,0)) or (colin0(st[niv-1],s)) ) and
  (l+abs(x[s]-x[st[niv-1]])+abs(y[s]-y[st[niv-1]])<=lmax)
then
  begin
    used[s]:=true;
    st[niv]:=s;
    l:=l+(abs(x[s]-x[st[niv-1]])+abs(y[s]-y[st[niv-1]]));

    back(niv+1);

    l:=l-(abs(x[s]-x[st[niv-1]])+abs(y[s]-y[st[niv-1]]));
    st[niv]:=0;
    used[s]:=false;
  end;
end;

begin
t1:=t2;
assign(input,filein);
reset(input);
readln(n);

x[0]:=0; y[0]:=0;
for i:=1 to n do
  readln(x[i],y[i]);
readln(lmax);
close(input);

max:=1;
sol[0]:=0;

fillchar(used,sizeof(used),false);
used[0]:=true;
for i:=1 to n do
  begin
    used[i]:=true;
    st[1]:=i;
    l:=x[i]+y[i];

    if (2*l<=lmax) then
      begin
        if (max<2) then
          begin
            max:=2;
            sol[1]:=i;
          end;

        back(2);
      end;

    st[1]:=0;
    used[i]:=false;
  end;

print;
end.