uses dos;
const dl:array[1..8] of -1..1=(-1,-1,-1,0,0,1,1,1);
      dc:array[1..8] of -1..1=(-1,0,1,-1,1,-1,0,1);
type pelem=^elem;
     elem=record l,c:byte; next:pelem end;
var lac:array[0..100,0..100] of 0..1;
    cost:array[0..100,0..100] of byte;
    directie:array[0..100,0..100] of 1..8;
    pc,uc,p0,u0:pelem;
    min,nl,nc,i,j:byte;
    h,m,s,hs:word;

procedure push(linie,coloana:byte; var p,u:pelem);
var q:pelem;
begin
   new(q);
   q^.l:=linie; q^.c:=coloana;
   q^.next:=nil;
   if p=nil
      then p:=q
      else u^.next:=q;
   u:=q;
end;

procedure pop(var linie,coloana:byte; var p,u:pelem);
var q:pelem;
begin
   q:=p;
   linie:=q^.l; coloana:=q^.c;
   if p=u then u:=nil;
   p:=p^.next;
   dispose(q);
end;


procedure init;
var i,j,i1,j1:byte;
    f:text;
begin
   assign(f,'lac.in'); reset(f);
   readln(f,nl,nc);
   fillchar(lac,sizeof(lac),0);
   fillchar(directie,sizeof(directie),7);
{  for i:=0 to nc+1 do cost[0,i]:=9;} { Bordare sa n-o ia in sus }
   for i:=1 to nl do
      begin
         cost[i,0]:=i; cost[i,nc+1]:=i;
         for j:=1 to nc do
            begin
               read(f,lac[i,j]);
               cost[i,j]:=i;
               if lac[i,j]=0
                  then
                     push(i,j,p0,u0);
            end;
         readln(f);
      end;
   for j:=0 to nc+1 do
      cost[nl+1,j]:=nl+1;
   close(f);
end;

function OK (l0,c0:byte):boolean;
var l1,c1,i:byte;
begin
   OK:=true;
   for i:=1 to 8 do
      begin
         l1:=l0+dl[i]; c1:=c0+dc[i];
         if cost[l1,c1]<cost[l0,c0]
            then
               begin
                  cost[l0,c0]:=cost[l1,c1]; directie[l0,c0]:=9-i;
                  OK:=false;
               end;
      end;
end;

procedure reconfig;
var l0,c0,l1,c1,nou,i,j:byte;
begin
   while pc<>nil do
      begin
         pop(l0,c0,pc,uc);
         for i:=1 to 8 do
            begin
               l1:=l0+dl[i]; c1:=c0+dc[i];
               nou:=cost[l0,c0]+lac[l1,c1];
               if nou<cost[l1,c1]
                  then
                     if l1*c1*(nl+1-l1)*(nc+1-c1)<>0
                        then
                           begin
                              push(l1,c1,pc,uc);
                              cost[l1,c1]:=nou; directie[l1,c1]:=i;
                           end;
            end;
      end;
end;

procedure config;
var l0,c0,i1,j1:byte;
begin
   while p0<>nil do
      begin
         pop(l0,c0,p0,u0);
         if not OK(l0,c0)
            then
               begin
                  push(l0,c0,pc,uc);
                  reconfig;
               end;
      end;
end;

procedure solutie;
var i,l0,c0,i1,j1,x1,y1:byte;
begin
   config;
   min:=cost[nl,1];
   c0:=1;
   for i:=2 to nc do
      begin
         if cost[nl,i]<min
            then
               begin
                  min:=cost[nl,i]; c0:=i;
               end;
      end;
   l0:=nl;
   repeat
      x1:=l0; y1:=c0;
      lac[l0,c0]:=lac[l0,c0]+2;
      i:=directie[l0,c0];
      l0:=l0-dl[i];
      c0:=c0-dc[i];
   until l0=0;
end;

procedure afisare;
var i,j:integer;
    g:text;
begin
   assign(g,'lac.out'); rewrite(g);
   writeln(g,min);
   for i:=1 to nl do
      for j:=1 to nc do
         if lac[i,j]=3
            then writeln(g,i,' ',j);
   close(g);
end;

BEGIN
   init;
   solutie;
   afisare;
END.

