{ Mugurel Ionut Andreica - Bucuresti, ROMANIA }

{ Time Complexity: O(K*N) }

{$S-,I-,R-,Q-,N+}
{$M 65000,0,655360}
Program GARD;

const filein='gard.IN';
      fileout='gard.OUT';
      MAXN=16000;
      MAXK=100;

type longarray=array[0..MAXN] of longint;
     plongarray=^longarray;

var fin,fout:text;
    li,pi,si,ind:array[1..MAXK] of longint;
    last,act,best:plongarray;
    i,j,k,m,n,p,q,l,ka,cmax:longint;

begin
assign(fin,filein);
reset(fin);
readln(fin,n,ka);

for k:=1 to ka do
  begin
    readln(fin,li[k],pi[k],si[k]);
    ind[k]:=k;
  end;
close(fin);

{ Sorteaza in functie de Si }
for i:=1 to ka-1 do
  for j:=i+1 to ka do
    if (si[ind[i]]>si[ind[j]]) then
      begin
        p:=ind[i]; ind[i]:=ind[j]; ind[j]:=p;
      end;
{ END Sorteaza }

new(last);
new(act);
fillchar(last^,sizeof(longarray),0);
new(best);
fillchar(best^,sizeof(best^),0);

p:=ind[1];
for i:=0 to si[p]-1 do
  best^[i]:=pi[p]*(n-i);

for k:=1 to ka do
  begin
    move(last^,act^,sizeof(longarray));
    p:=ind[k];

    for i:=si[p] to si[p]+li[p] do
      if (i>n) then
        break
      else
        begin
          l:=i-li[p];
          if (l<0) then l:=0;

          cmax:=best^[l]-pi[p]*(n-i);

          if (cmax>act^[i]) then
            act^[i]:=cmax;
        end;

    cmax:=act^[0];
    for i:=1 to n do
      if (act^[i]>cmax) then
        cmax:=act^[i]
      else
        act^[i]:=cmax;

    move(act^,last^,sizeof(longarray));

    if (k<ka) then
      begin
        fillchar(best^,sizeof(best^),0);
        p:=ind[k+1];

        best^[si[p]-1]:=act^[si[p]-1]+pi[p]*(n-si[p]+1);

        for i:=si[p]-2 downto si[p]-li[p] do
          begin
            if (i<0) then break;

            cmax:=pi[p]*(n-i)+act^[i];
            if (cmax>best^[i+1]) then
              best^[i]:=cmax
            else
              best^[i]:=best^[i+1];
          end;
      end;
  end;

cmax:=0;
for i:=1 to n do
  if (act^[i]>cmax) then
    cmax:=act^[i];

assign(fout,fileout);
rewrite(fout);
writeln(fout,cmax);
close(fout);
end.