#include <stdio.h>
#include <process.h>

#define FNAME "monede.in"
#define FONAME "monede.out"

typedef char taler[1000];

int _nom_n , _nom_k, _nom_t, _nom_cant_nr=0;
int _nom_apelat_init=0;
FILE *fo;

int de(int x){ return x/2; }

int init(void){
FILE *f;
  fo=fopen(FONAME, "w");
  f=fopen(FNAME, "r");
  if(f==NULL){
    fputs("EROARE Nu pot deschide fisierul MONEDE.in\n", fo);
    fclose(fo);
    exit(0);
  }
  if( (fscanf(f,"%d%d%d", &_nom_n, &_nom_k, &_nom_t)!=3)
      || (de(_nom_n)<3) || (de(_nom_n)>1000) || (de(_nom_k)<0) || (de(_nom_k)>=de(_nom_n))
      || ((de(_nom_t)!=1) && (de(_nom_t)!=-1)) ) {
    fputs("EROARE Fisierul MONEDE.in nu respecta formatul cerut\n", fo);
    fclose(fo);
    exit(0);
  };
  fclose(f);
  _nom_apelat_init=1;
  return de(_nom_n);
}

int cantarire(taler stanga, taler dreapta) {
int i, s, d, rez;
  if(!_nom_apelat_init){
    fputs("KO Apel pentru cantarire inainte de init\n", fo);
    fclose(fo);
    exit(0);
  }
  s=0; d=0; rez=0;
  for(i=0;i<de(_nom_n);i++){
    if( (stanga[i]<0) || (stanga[i]>1) ||
       (dreapta[i]<0) || (dreapta[i]>1) ||
       ((dreapta[i]==1) && (stanga[i]==1))){
       fputs("KO Apel incorect pentru cantarire\n", fo);
       fclose(fo);
       exit(0);
    }
    if(stanga[i]==1){
      s++;
      if(i==de(_nom_k))rez=de(_nom_t);
    }
    if(dreapta[i]==1){
      d++;
      if(i==de(_nom_k))rez=-de(_nom_t);
    }
  };
  if(s!=d){
    fputs("KO Apel incorect pentru cantarire\n", fo);
    fclose(fo);
    exit(0);
  }
  fprintf(fo, "CANTARIRE %d\n", ++_nom_cant_nr);
  fflush(fo);
  return rez;
}

void rezultat(int moneda, int tip){
  if(!_nom_apelat_init){
    fputs("KO Apel pentru rezultat inainte de init\n", fo);
    fclose(fo);
    exit(0);
  };
  if( (moneda!=de(_nom_k)) || (de(_nom_t)!=tip) )
    fprintf(fo, "KO Rezultat incorect\n");
  else
    fprintf(fo, "REZULTAT %d %d\n", moneda, tip);
  fclose(fo);
  exit(0);
}

