#include <stdio.h>
#include <process.h>

#define FNAME "monede.in"
typedef char taler[1000];

int _mon_n , _mon_k, _mon_t, _mon_cant_nr=0;
int _mon_apelat_init=0;

int init(void){
FILE *f;
  f=fopen("monede.in", "rt");
  if(f==NULL){
    puts("*** Nu pot deschide fisierul MONEDE.in");
    puts("*** Cititi explicatiile din textul problemei");
    exit(0);
  }
  if( (fscanf(f,"%d%d%d", &_mon_n, &_mon_k, &_mon_t)!=3)
      || (_mon_n<3) || (_mon_n>1000) || (_mon_k<0) || (_mon_k>=_mon_n)
      || ((_mon_t!=1) && (_mon_t!=-1)) ) {
    puts("*** Fisierul MONEDE.in nu respecta formatul cerut");
    puts("*** Cititi explicatiile din textul problemei");
    exit(0);
  };
  fclose(f);
  _mon_apelat_init=1;
  return _mon_n;
}

int cantarire(taler stanga, taler dreapta) {
int i, s, d, rez;
  if(!_mon_apelat_init){
    puts("*** Apel pentru cantarire inainte de init");
    exit(0);
  }
  s=0; d=0; rez=0;
  for(i=0;i<_mon_n;i++){
    if( (stanga[i]<0) || (stanga[i]>1) ||
       (dreapta[i]<0) || (dreapta[i]>1) ||
       ((dreapta[i]==1) && (stanga[i]==1))){
       puts("*** Apel incorect pentru cantarire");
       exit(0);
    }
    if(stanga[i]==1){
      s++;
      if(i==_mon_k)rez=_mon_t;
    }
    if(dreapta[i]==1){
      d++;
      if(i==_mon_k)rez=-_mon_t;
    }
  };
  if(s!=d){
    puts("*** Apel incorect pentru cantarire");
    exit(0);
  }
  printf("Cantarire %d !\n", ++_mon_cant_nr);
  return rez;
}

void rezultat(int moneda, int tip){
  if(!_mon_apelat_init){
    puts("*** Apel pentru rezultat inainte de init");
    exit(0);
  };
  printf("*** Apel rezultat cu %d si %d\n", moneda, tip);
}

