#include <stdio.h>
#include <stdlib.h>
#include <alloc.h>
#include <mem.h>

typedef struct pom{ int x,y,z;} pom;
pom *tre,*tmp;
//pom tre[20],tmp[20];

typedef struct nod{ int v; struct nod *urm;} nod;
nod *sq[16000];

int huge z[16000];
int huge z2[16000];
int nz,nz2;
short huge v[16000];
int cs;
FILE *fi,*fo;
int nr,k;

void in(){
	int i;
	fi = fopen("banana.in","r");
	fscanf(fi,"%d %d",&nr,&k);
	for (i=0; i<nr; i++) fscanf(fi,"%d %d",&tre[i].x,&tre[i].y);
	fclose(fi);
}

int less(pom a, pom b){
	if (a.x<b.x || (a.x==b.x && a.y<b.y)) return 1;
	return 0;
}

int equal(pom a, pom b){
	if (a.x==b.x && a.y == b.y) return 1;
	return 0;
}

void sort(pom *a, int n){
	int i,j,mid = n>>1;
	pom au;

	if (n<4){
		for (i=0; i<n-1; i++)
			for (j=i+1; j<n; j++)
				if (less(a[j],a[i])) au = a[j], a[j] = a[i], a[i] = au;
		return;
	}
	sort(a,mid);
	sort(a+mid,n-mid);
	memcpy(tmp,a,6*n);
	for (i=0, j=mid;i<mid ||j<n;)
		if (i<mid && (less(tmp[i],tmp[j]) || j==n)) *(a++)=tmp[i++];
		else *(a++)=tmp[j++];
}

void sort2(int huge *a, int n){
	int i,j,mid = n>>2,au;
	if (n<4){
		for (i=0; i<n-1; i++)
			for (j=i+1; j<n; j++)
				if (a[j]<a[i]) au = a[j], a[j] = a[i], a[i] = au;
		return;
	}
	sort2(a,mid);
	sort2(a+mid,n-mid);
	memcpy(z,(void*)a,2*n);
	for (i=0, j=mid; i<mid || j<n; )
		if (i<mid && (z[i]<z[j] || j==n)) *(a++) = z[i++];
			else *(a++) = z[j++];
}

void solve(){
	int i,pdn = -1,plt = -1;
	pom dn,lt;
	nod *p;

	tre[0].z = 0;
	z[0] = 1;
	nz = 1;
	for (i=1; i<nr; i++){
		int s = 0, e = i-1, mid;
		pdn = plt = -1;
		dn.x = tre[i].x - 1;
		dn.y = tre[i].y;
		lt.x = tre[i].x;
		lt.y = tre[i].y - 1;
		s = 0, e = i-1;
		while (s<e){
			mid = (s+e)/2;
			if (less(dn,tre[mid])) e=mid-1;
			else if (equal(dn,tre[mid])) s=e=mid;
			else s = mid+1;
		}
		if (tre[s].x == dn.x && tre[s].y == dn.y) pdn = s;
		s = 0, e = i-1;
		while (s<e){
			mid = (s+e)/2;
			if (less(lt,tre[mid])) e=mid-1;
			else if (equal(lt,tre[mid])) s=e=mid;
			else s = mid+1;
		}
		if (tre[s].x == lt.x && tre[s].y == lt.y) plt = s;
		if (plt == -1 && pdn == -1){
			z[nz] = 1;
			tre[i].z = nz;
			nz++;
		} else
		if (plt == -1 && pdn != -1){
			tre[i].z = tre[pdn].z;
			z[tre[i].z]++;
		} else
		if (pdn == -1 && plt != -1){
			tre[i].z = tre[plt].z;
			z[tre[i].z]++;
		} else
		if (tre[pdn].z==tre[plt].z){
			tre[i].z = tre[pdn].z;
			z[tre[i].z]++;
		} else {
			tre[i].z = tre[pdn].z;
			z[tre[i].z]++;
			p = (nod*)calloc(1,6);
			p->v = tre[pdn].z;
			p->urm = sq[tre[plt].z];
			sq[tre[plt].z] = p;
			p = (nod*)calloc(1,6);
			p->v = tre[plt].z;
			p->urm = sq[tre[pdn].z];
			sq[tre[pdn].z] = p;
		}
	}
}

void df(int k){
	nod *p;

	v[k] =1;
	cs += z[k];
	p = sq[k];
	while (p){
		if (!v[p->v]) df(p->v);
		p = p->urm;
	}
}

void dup(){
	int i,j;
	for (i=0; i<nz; i++)
		if (!v[i]){
			cs = 0;
			df(i);
			z2[nz2] = cs;
			nz2++;
		}
}


int main(){
	int i;
	nod *p,*q;
	tre = (pom*)farmalloc(6*16000);
	tmp = (pom*)farmalloc(6*16000);
	in();
	sort(tre,nr);
	solve();
	dup();
	sort2(z2,nz2);
	freopen("banana.out","w",stdout);
	cs = 0;
	for (i=0; i<k; i++) cs += z2[nz2-1-i];
	printf("%d\n",cs);
	fclose(stdout);
	farfree(tre);
	farfree(tmp);
	for (i=0; i<nz; i++){
		p = sq[i];
		while (p){
			q=p;
			p=p->urm;
			free(q);
		}
	}

	return 0;
}