#include <stdio.h>
#include <mem.h>
#include <alloc.h>

#define fin "banana.in"
#define fout "banana.out"

#define left(i) ((i<<1)+1)
#define right(i) ((i<<1)+2)

int n,k;

int i,j;
struct lista
{
int x,y;
int ord;
lista* next;
};

lista* v[5000];
int x,y;


void Sift(int i,int *heap,int n)
{
int son,temp;
	if (left(i)<n)
		{
		son=left(i);
		if (right(i)<n && heap[right(i)]>heap[son])
			son++;
		}
	else son=0;
	while (son)
		{
		if (heap[i]>=heap[son])
			return;
		temp=heap[i]; heap[i]=heap[son]; heap[son]=temp; i=son;
		if (left(i)<n)
			{
			son=left(i);
			if (right(i)<n && heap[right(i)]>heap[son])
				son++;
			}
		else son=0;
		}
}

void BuildHeap(int *heap,int HeapSize)
{
int i;
	for (i=HeapSize/2;i>=0;i--)
		Sift(i,heap,HeapSize);
}


void Insert(int x,int y,int ord)
{
lista *p;
long ind=((long)x*10000+y)%4999;
	p=(lista*)malloc(sizeof(lista));
	p->x=x; p->y=y; p->next=v[ind];
	p->ord=ord;
	v[ind]=p;
}

int huge cx[10001],huge cy[100001];
int huge tata[16001];
int contine[16001];
int huge rank[16001];

int FS(int i)
{
	if (!tata[i])
		return i;
	return tata[i]=FS(tata[i]);
}


void US(int i,int j)
{
i=FS(i);
j=FS(j);
	if (rank[i]<rank[j])
		{
		tata[i]=j;
		return;
		}
	if (rank[j]<rank[i])
		{
		tata[j]=i;
		return;
		}
	rank[i]++;
	tata[j]=i;
}

void RD()
{
	freopen(fin,"rt",stdin);
	freopen(fout,"wt",stdout);
	scanf("%d%d",&n,&k);
/*	for (i=1;i<=n;i++)
	{
	} */
}

int Exista(int x,int y)
{
lista* p;
int ind=((long)x*10000+y)%4999;
	if (x<1 || y<1)
		return 0;
	p=v[ind];
	while (p)
		{
		if (p->x==x && p->y==y)
			return p->ord;
		p=p->next;
		}
	return 0;
}

void main()
{
//long left=farcoreleft();
int tat=0;
	RD();
	for (i=1;i<=n;i++)
		{
	scanf("%d%d",&x,&y);
	cx[i]=x; cy[i]=y;
	Insert(x,y,i);

		tat=Exista(cx[i]-1,cy[i]);
		if (tat)
			{
			US(i,tat);
			}
		tat=Exista(cx[i]+1,cy[i]);
		if (tat)
			{
			US(i,tat);
			}
		tat=Exista(cx[i],cy[i]+1);
		if (tat)
  			{
			US(i,tat);
			}
		tat=Exista(cx[i],cy[i]-1);
		if (tat)
			{
			US(i,tat);
			}
		}

int gr;
	for (i=1;i<=n;i++)
		{
		gr=FS(i);
          contine[gr]++;
		}
long rez=0;

	BuildHeap(contine,n);
	for (i=1;i<=k;i++)
		{
		rez+=contine[0];
		contine[0]=contine[n];
		n--;
		Sift(0,contine,n);
		}
	printf("%ld",rez);
}