program banana;
type copac=record
     x,y:word;
     p: longint;
             end;
     ctrl=array[1..10000]of boolean;
     zona=record
     valid: boolean;
     c: ctrl;
     n: longint;
            end;
var f: text;
    cop: array[1..16000] of ^copac;
    c,i,j,n,nb:longint;
    zone:array[1..140] of ^zona;
    ez,iz,z: word;

procedure QSort(l, r: Integer);
var
  i, j: integer;
  x, y: copac;
begin
  i := l; j := r; x := cop[(l+r) DIV 2]^;
  repeat
    while cop[i]^.p < x.p do i := i + 1;
    while x.p < cop[j]^.p do j := j - 1;
    if i <= j then
    begin
      y := cop[i]^; cop[i]^ := cop[j]^; cop[j]^ := y;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then QSort(l, j);
  if i < r then QSort(i, r);
end;

procedure ZoneSort(l, r: Integer);
var
  i, j: integer;
  x, y: ^zona;
begin
  new(x); new(y);
  i := l; j := r; x^ := zone[(l+r) DIV 2]^;
  repeat
    while zone[i]^.n > x^.n do i := i + 1;
    while x^.n > zone[j]^.n do j := j - 1;
    if i <= j then
    begin
      y^ := zone[i]^; zone[i]^ := zone[j]^; zone[j]^ := y^;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  dispose(x); dispose(y);
  if l < j then ZoneSort(l, j);
  if i < r then ZoneSort(i, r);
end;

begin
{CITIRE}
assign(f,'Banana.in'); reset(F);
read(f,n);
{*****INITIALIZARE}
for i := 1 to n do begin
    new(cop[i]);
    read(f,cop[i]^.x);
    readln(f,cop[i]^.y);
    cop[i]^.p:=cop[i]^.y*10001+cop[i]^.x;
                    end;
{SORTARE}
QSort(1,n);
{CALCUL ZONE}
z := 0;
for i := 1 to n do begin
ez := iz; iz := 0;
for j := 1 to z do begin
if (zone[j]^.valid)and((zone[j]^.c[cop[i]^.x])
   or((cop[i-1]^.p=cop[i]^.p-1)and(zone[j]^.c[cop[i-1]^.x]))) then
       if iz=0 then begin
         {NOT IN ANY ZONE => ADD TO J}
          zone[j]^.c[cop[i]^.x]:=true;
          inc(zone[j]^.n);
          iz := z;
                     end
       else begin
         {ALREADY IN ZONE => MERGE ZONES J+IZ}
         zone[j]^.valid:=false;
         for c := 1 to 10000 do zone[iz]^.c[c]:=zone[iz]^.c[c] or zone[j]^.c[c];
         zone[iz]^.c[cop[i]^.y]:=true;
         inc(zone[iz]^.n,1+zone[j]^.n);
         zone[j]^.n:=0;
            end;
                    end;
    if iz = 0 then begin
         {NOT IN ANY ZONE => CREATE A NEW ZONE}
         inc(z); NEW(zone[z]);
         zone[z]^.valid:=true;
         zone[z]^.c[cop[i]^.x]:=true;
         zone[z]^.n := 1;
         iz := z;
                   end;
                   end;


{SORTARE ZONE}
ZoneSort(1,z);

{CALCUL NB}
nb:=0;
for i := 1 to z do nb:=nb+zone[i]^.n;
{SCRIERE}
assign(f,'Banana.out'); rewrite(F);
write(f,nb);
close(f);
end.