{$A+,B-,D+,E+,F-,G-,I-,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 65520,0,655360}
const
  nmax = 16000;
  finame = 'BANANA.in';
  foname = 'BANANA.out';
type
  punct = record
            x, y: integer;
          end;
  vector = array[1..nmax] of punct;
  vecint = array[1..nmax] of integer;
var
  fi, fo: text;
  n, k: integer;
  a, b: ^vector;
  p, r: vecint;
  q, qq: ^vecint;
  total: integer;

procedure readdata;
var i: integer;
begin
  assign(fi, finame);
  reset(fi);
  readln(fi, n, k);
  new(a); new(b);
  for i := 1 to n do
    readln(fi, a^[i].x, a^[i].y);
  close(fi);
end;

procedure mergey(l, c, r: integer);
var i, j, k: integer;
begin
  i := l; j := c+1; k := l;

  while (i <= c) and (j <= r) do
  begin
    if (a^[i].y < a^[j].y)
    or((a^[i].y = a^[j].y) and (a^[i].x < a^[j].x)) then
    begin
      qq^[k] := q^[i];
      b^[k] := a^[i];
      inc(i); inc(k);
    end else
    begin
      qq^[k] := q^[j];
      b^[k] := a^[j];
      inc(j); inc(k);
    end;
  end;

  while (i <= c) do
  begin
    qq^[k] := q^[i];
    b^[k] := a^[i];
    inc(i); inc(k);
  end;

  while (j <= r) do
  begin
    qq^[k] := q^[j];
    b^[k] := a^[j];
    inc(j); inc(k);
  end;

  for k := l to r do
  begin
    q^[k] := qq^[k];
    a^[k] := b^[k];
  end;
end;

procedure sortfory(l, r: integer);
var c: integer;
begin
  if l < r then
  begin
    c := (l+r) div 2;
    sortfory(l, c);
    sortfory(c+1, r);
    mergey(l, c, r);
  end;
end;

procedure mergex(l, c, r: integer);
var i, j, k: integer;
begin
  i := l; j := c+1; k := l;

  while (i <= c) and (j <= r) do
  begin
    if (a^[i].x < a^[j].x)
    or((a^[i].x = a^[j].x) and (a^[i].y < a^[j].y)) then
    begin
      b^[k] := a^[i];
      inc(i); inc(k);
    end else
    begin
      b^[k] := a^[j];
      inc(j); inc(k);
    end;
  end;

  while (i <= c) do
  begin
    b^[k] := a^[i];
    inc(i); inc(k);
  end;

  while (j <= r) do
  begin
    b^[k] := a^[j];
    inc(j); inc(k);
  end;

  for k := l to r do
    a^[k] := b^[k];
end;

procedure sortforx(l, r: integer);
var c: integer;
begin
  if l < r then
  begin
    c := (l+r) div 2;
    sortforx(l, c);
    sortforx(c+1, r);
    mergex(l, c, r);
  end;
end;

function tata(x: integer): integer;
begin
  if p[x] = x
    then tata := x
    else p[x] := tata(p[x]);
  tata := p[x];
end;

procedure uneste(i, j: integer);
var pi, pj: integer;
begin
  pi := tata(i);
  pj := tata(j);
  if pi <> pj then
  begin
    if r[pi] <= r[pj]
      then p[pi] := pj  { j <- i }
      else p[pj] := pi; { i <- j }
    if r[pi] = r[pj] then
      inc(r[pj]);
  end;
end;

procedure initdata;
{ gasim componentele conexe }
var i, j: integer;
begin
  for i := 1 to n do
  begin
    p[i] := i;
    r[i] := 0;
  end;

  sortforx(1, n);
  for i := 2 to n do
    if abs(a^[i].x - a^[i-1].x) + abs(a^[i].y - a^[i-1].y) = 1 then
      uneste(i-1, i);

  new(q); new(qq);
  for i := 1 to n do
    q^[i] := i;
  sortfory(1, n);

{ refacem vectorul p }
{ tot ce pointa la pozitia p[i] trebuie sa pointeze la i }
  for i := 1 to n do
    qq^[ q^[i] ] := i;

  q^ := p;
  for i := 1 to n do
    p[qq^[i]] := qq^[q^[i]];

{ mai facem o reuniune mica }
  for i := 2 to n do
    if abs(a^[i].x - a^[i-1].x) + abs(a^[i].y - a^[i-1].y) = 1 then
      uneste(i-1, i);

{ reducerea drumului pentru toate nodurile }
  for i := 1 to n do
    j := tata(i);
end;


procedure solvprob;
var i: integer;
begin
{ a[i].x - suprafata figurii cu tatal i }
  fillchar(a^, sizeof(a^), 0);
  for i := 1 to n do
    inc(a^[p[i]].x);

  sortforx(1, n);

  total := 0;
  for i := n downto n-k+1 do
    inc(total, a^[i].x);
end;

procedure writesol;
begin
  assign(fo, foname);
  rewrite(fo);
  writeln(fo, total);
  close(fo);
end;


begin
  readdata;
  initdata;
  solvprob;
  writesol;
end.