{$A+,B-,D+,E+,F-,G-,I-,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 65520,0,655360}
const
  kmax = 101;  { 100 }
  finame = 'GARD.in';
  foname = 'GARD.out';
var
  fi, fo: text;
  n, k, i, j, t: integer;
  l, p, s: array[0..kmax] of integer;
  a: array[0..kmax] of array[0..kmax] of longint;
  z: array[0..kmax] of array[0..kmax] of integer;
  li, lj, ll, cost: longint;

procedure readdata;
begin
  assign(fi, finame);
  reset(fi);
  readln(fi, n, k);
  for i := 1 to k do
    readln(fi, l[i], p[i], s[i]);
  close(fi);
end;

procedure sortdata;
var i, j, aux: integer;
begin
  for i := 1 to k-1 do
    for j := i+1 to k do
      if s[i] > s[j] then
      begin
        aux := s[i]; s[i] := s[j]; s[j] := aux;
        aux := l[i]; l[i] := l[j]; l[j] := aux;
        aux := p[i]; p[i] := p[j]; p[j] := aux;
      end;
end;

function min(a, b: longint): longint;
begin
  if a < b then min := a else min := b;
end;

procedure solvprob;
begin
  fillchar(a, sizeof(a), 0);
  inc(k);
  s[k] := n+1;
  l[k] := n+1;
  p[k] := 0;
  s[0] := 0;
  l[0] := n+1;
  p[0] := 0;

  for i := 0 to k-1 do
    for j := i+1 to k do
    begin
      if s[i]+l[i]+l[j]-1 <= s[j] then
      begin
        a[i][j] := l[i]*p[i] + l[j] * p[j];
        if j = k then
          z[i][j] := 0
        else
          z[i][j] := l[j];
      end
      else
      begin
        if p[i] > p[j] then
        begin
          li := min(l[i], s[j]-s[i]);
          lj := (s[j] - s[i] + 1) - li;
          a[i][j] := li*p[i] + lj*p[j];
          if j = k then
            z[i][j] := 0
          else
            z[i][j] := lj;
        end else
        begin
          lj := min(l[j], s[j]-s[i]);
          li := (s[j] - s[i] + 1) - lj;
          a[i][j] := li*p[i] + lj*p[j];
          if j = k then
            z[i][j] := 0
          else
            z[i][j] := lj;
        end;
      end;
    end;

  for ll := 2 to k do
    for i := 0 to k do
    begin
      j := i + ll;
      if j <= k then
      begin
        for t := i+1 to j-1 do
        begin
          cost := a[i][t] + a[t][j] - min(z[i][t] * p[t], z[t][j] * p[j]);
            if cost > a[i][j] then
              a[i][j] := cost;
        end;
      end;
    end;
end;

procedure writesol;
begin
  assign(fo, foname);
  rewrite(fo);
  cost := 0;
  for i := 1 to k-1 do
    for j := 1 to k-1 do
      if a[i][j] > cost then
        cost := a[i][j];
  writeln(fo, cost);
  close(fo);
end;

begin
  readdata;
  sortdata;
  solvprob;
  writesol;
end.