#include <stdio.h>
#include <alloc.h>

struct lista
{
	int cl;
	struct lista *urm;
};

int nr, k, nrz = 0, cmax[2], zmax, nrb = 0;
int far c[2][16001], huge m[4][16001], far cs[16001], far z[16001];
lista far *lc[10001];

void radix( int cc )
{
	int pc, i, j;
	lista *p, *q;

	for( i = nr ; i >= 1 ; i-- )
	{
		pc = c[cc][cs[i]];

		p = (lista far*)farmalloc( sizeof( lista ) );
		p->urm = NULL;
		p->cl = cs[i];
		if( !lc[pc] )
			lc[pc] = p;
		else
		{
			p->urm = lc[pc];
			lc[pc] = p;
		}
	}

	j = 0;
	for( i = 1 ; i <= cmax[cc] ; i++ )
	{
		for( p = lc[i] ; p ; p = q )
		{
			cs[++j] = p->cl;

			q = p->urm;
			farfree( p );
		}
		lc[i] = NULL;
	}
}

int df( int vf )
{
	int i, val = 1;

	if( !vf || cs[vf] )
		return 0;

	cs[vf] =  1;
	for( i = 0 ; i < 4 ; i++ )
		val += df( m[i][vf] );
	return val;
}

void main( )
{
	FILE *f;
	int i, j;

	f = fopen( "banana.in", "r" );
	fscanf( f, "%d %d", &nr, &k );

	for( i = 1 ; i <= nr ; i++ )
	{
		cs[i] = i;
		fscanf( f, "%d %d", &c[0][i], &c[1][i] );
		if( c[0][i] > cmax[0] )
			cmax[0] = c[0][i];
		if( c[1][i] > cmax[1] )
			cmax[1] = c[1][i];
	}
	fclose( f );

	radix( 1 );
	radix( 0 );
	for( i = 1 ; i < nr ; i++ )
		if( c[0][cs[i]] == c[0][cs[i+1]] && c[1][cs[i]]+1 == c[1][cs[i+1]] )
		{
			m[1][cs[i]] = cs[i+1];
			m[3][cs[i+1]] = cs[i];
		}
	radix( 1 );
	for( i = 1 ; i < nr ; i++ )
		if( c[0][cs[i]]+1 == c[0][cs[i+1]] && c[1][cs[i]] == c[1][cs[i+1]] )
		{
			m[2][cs[i]] = cs[i+1];
			m[0][cs[i+1]] = cs[i];
		}

	for( i = 1 ; i <= nr ; i++ )
		cs[i] = 0;
	for( i = 1 ; i <= nr ; i++ )
		if( !cs[i] )
			z[nrz++] = df( i );

	for( i = 0 ; i <= nr ; i++ )
		cs[i] = 0;
	for( i = 0 ; i < nrz ; i++ )
	{
		cs[z[i]]++;
		if( z[i] > zmax )
			zmax = z[i];
	}

	for( i = zmax ; i > 0 && k > 0 ; i-- )
		if( k >= cs[i] )
		{
			nrb += i*cs[i];
			k -= cs[i];
		}
		else
		{
			nrb += i*k;
			k = 0;
		}

	f = fopen( "banana.out", "w" );
	fprintf( f, "%d", nrb );
	fclose( f );
}
