#include <fstream.h>

typedef struct {
		int L,P,S;
	       } Worker;

typedef struct {
		int v1,v2;
	       } Result;

Worker m[100],cw;

int n,k,i,j,i0,j0,c,nl=0,l[100][2];

void QSort(int ii,int fi)
{
 if (ii<fi)
 {
  int i=ii;
  j=fi;
  i0=0;
  j0=-1;
  while (i<j)
  {
   if (m[i].P<m[j].P)
   {
    cw=m[i];
    m[i]=m[j];
    m[j]=cw;
    c=i0;
    i0=-j0;
    j0=-c;
   }
   i+=i0;
   j+=j0;
  }
  QSort(ii,i-1);
  QSort(i+1,fi);
 }
}

Result GetLeft(int i)
{
 Result Res;
 Res.v1=m[i].S-m[i].L+1;
 Res.v2=-1;
 if (Res.v1<1)
  Res.v1=1;
 for (j=0;j<nl;j++)
  if ((l[j][1]>=Res.v1)&&(l[j][0]<=m[i].S))
  {
   Res.v1=l[j][1]+1;
   Res.v2=j;
  }
 return Res;
}

Result GetRight(int i)
{
 Result Res;
 Res.v1=m[i].S+m[i].L-1;
 Res.v2=-1;
 if (Res.v1>n)
  Res.v1=n;
 for (j=0;j<nl;j++)
  if ((l[j][0]<=Res.v1)&&(l[j][1]>=m[i].S))
  {
   Res.v1=l[j][0]-1;
   Res.v2=j;
  }
 return Res;
}

int LeftBest(int i)
{
 int lim[2],d[2];
 lim[0]=m[i].S-m[i].L+1;
 lim[1]=m[i].S;
 d[0]=d[1]=-1;
 for (j=i+1;j<k;j++)
  if ((m[j].S+m[j].L-1>=lim[0])&&(m[j].S<=lim[1]))
  {
   d[0]=m[j].S+m[j].L;
   if (d[0]>lim[1])
    d[0]=lim[1];
   break;
  }
  lim[0]=m[i].S;
  lim[1]=m[i].S+m[i].L-1;
 for (j=i+1;j<k;j++)
  if ((m[j].S<=lim[1])&&(m[j].S+m[j].L-1>=lim[0]))
  {
   d[1]=m[j].S-1;
   if (d[1]<lim[0])
    d[1]=lim[0];
   break;
  }
 if (d[0]==-1)
  return 1;
 else
  if (d[1]==-1)
   return 0;
  else
   return (d[0]>d[1]);
}

void main(void)
{
 fstream fi("gard.in",ios::in);
 fstream fo("gard.out",ios::out);
 int i;
 Result r1,r2;
 unsigned long int Res=0;

 fi>>n>>k;
 for (i=0;i<k;i++)
  fi>>m[i].L>>m[i].P>>m[i].S;
 QSort(0,k-1);
 for (i=0;i<k;i++)
 {
  r1=GetLeft(i);
  r2=GetRight(i);
  if (m[i].S-r1.v1+1>r2.v1-m[i].S+1)
  {
   l[nl][0]=r1.v1;
   l[nl][1]=m[i].S;
  }
  else
   if (m[i].S-r1.v1+1<r2.v1-m[i].S+1)
   {
    l[nl][0]=m[i].S;
    l[nl][1]=r2.v1;
   }
   else
   {
    if (r1.v2!=-1)
    {
     l[nl][0]=r1.v1;
     l[nl][1]=m[i].S;
    }
    else
     if (r2.v2!=-1)
     {
      l[nl][0]=m[i].S;
      l[nl][1]=r2.v1;
     }
    else
     if (LeftBest(i))
     {
      l[nl][0]=r1.v1;
      l[nl][1]=m[i].S;
     }
     else
     {
      l[nl][0]=m[i].S;
      l[nl][1]=r2.v1;
     }
   }
  if (l[nl][1]>=l[nl][0])
  {
   Res+=(unsigned long int)(l[nl][1]-l[nl][0]+1)*m[i].P;
   nl++;
  }
 }
 fo<<Res;

 fo.close();
 fi.close();
}