#include <stdio.h>
#include <string.h>

struct muncitor
{
    int L;
    long P;
    int S;
} M[101];
int N, K;

long far L[16001], far A[16001];


long far X[16001];

void baga(int l, long p, int s)
{
    int i, ll;
    _fmemset(X, 0, sizeof(X));
    for (i = 0; i < l && s-i > 0; i++)
        X[i] = p*(long)(i+1) + L[s-i-1];
    for (i = 1; i < l; i++)
        if (X[i-1] > X[i]) X[i] = X[i-1];
    A[s] = X[l-1];
    for (i = 1; i < l && l-i > 0 && s+i <= N; i++)
        A[s+i] = X[l-i-1]+p*(long)i;
    for (i = 1; i <= N; i++)
        if (A[i-1] > A[i]) A[i] = A[i-1];
    for (i = 0; i <= N; i++)
        if (A[i] < L[i])
            A[i] = L[i];
        else
            L[i] = A[i];
}


void solve()
{
    muncitor m;
    int i, j;
    for (i = 0; i < K; i++)
        for (j = i+1; j < K; j++)
            if (M[i].S > M[j].S) m = M[i], M[i] = M[j], M[j] = m;
    for (i = 0; i < K; i++)
        baga(M[i].L, M[i].P, M[i].S);
}

void print()
{
    FILE *fo = fopen("GARD.OUT", "wt");
    fprintf(fo, "%ld\n", A[N]);
    fclose(fo);
}

void read_data()
{
    FILE *fi = fopen("GARD.IN", "rt");
    int i;
    fscanf(fi, "%d %d", &N, &K);
    for (i = 0; i < K; i++)
        fscanf(fi, "%d %ld %d", &M[i].L, &M[i].P, &M[i].S);
    fclose(fi);
}

void main()
{
    read_data();
    solve();
    print();
}