#pragma option -3 -G -Z -O2
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

long far gcm[16008];

int wl[128], wp[128], w0[128];
int ndx[128];

int wcmp(void const *a, void const *b) {
	return w0[*(int *)a] - w0[*(int *)b];
}

long far gcx[16008];
int far hpndx[16008];
#define isGreater(a, b)			(gcx[hpndx[a]] > gcx[hpndx[b]])
#define doSwap(a, b)				t = hpndx[a]; hpndx[a] = hpndx[b]; hpndx[b] = t;
void heap_gen(int m) {
	int x, y;
	int t;

	for(y = 1; y <= m; y++) {
		hpndx[y] = y - 1;
		x = y;
		while(x > 1 && isGreater(x, x >> 1)) {
			doSwap(x, x >> 1);
			x >>= 1;
		}
	}
}
void heap_delmin(int m) {
	int x, w;
	int t;

	doSwap(1, m);
	x = 1;
	m--;
	while((x << 1) <= m)  {
		if((x << 1) < m && isGreater((x << 1) + 1, x << 1))
			w = (x << 1) + 1;
		else
			w = x << 1;
		if(!isGreater(w, x))
			break;
		doSwap(x, w);
		x = w;
	}
}

int main() {
	FILE *fp;
	int x, y, yp, n, k;
	long mc;
	long ms;
	int cc, mpos, l, m;
	int hs;

	fp = fopen("gard.in", "rt");
	fscanf(fp, "%d%d", &n, &k);
	for(x = 0; x < k; x++) {
		fscanf(fp, "%d%d%d", &wl[x], &wp[x], &w0[x]);
		ndx[x] = x;
	}
	fclose(fp);

	qsort(ndx, sizeof(int), k, wcmp);

	for(x = 0; x < k; x++) {
		m = max(0, w0[ndx[x]] - wl[ndx[x]]);
		cc = wp[ndx[x]];
		hs = 0;
		for(y = w0[ndx[x]] - 1; y >= m; y--) {
			gcx[hs] = gcm[y] + (long)cc * hs;
			hs++;
		}
		heap_gen(hs);

		l = min(w0[ndx[x]] + wl[ndx[x]], n + 1);
		yp = 0;
		for(y = w0[ndx[x]]; y < l; y++, yp++) {
			while(hs && yp + hpndx[1] >= wl[ndx[x]]) {
				heap_delmin(hs);
				hs--;
			}

			if(hs)
				mc = gcx[hpndx[1]] + (long)cc * (y - w0[ndx[x]] + 1);
			else
				mc = (long)cc * (y - w0[ndx[x]] + 1);

			if(gcm[y] < mc)
				gcm[y] = mc;
			if(gcm[y] < gcm[y - 1])
				gcm[y] = gcm[y - 1];
		}

		for(; y <= n && gcm[y] < gcm[l - 1]; y++)
			gcm[y] = gcm[l - 1];
	}

	fp = fopen("gard.out", "wt");
	fprintf(fp, "%ld\n", gcm[n]);
	fclose(fp);

	return 0;
}