#include <fstream.h>
#include <stdlib.h>

typedef struct Tp
{
  int nod, x, y;
  Tp * tata, * Pnext;
};

typedef struct Tl
{
  int num, nod;
  Tl * Pnext;
};

void input();
void combine(Tp *, Tp *);
int sf(const void *, const void *);

ifstream fin("banana.in");
ofstream fout("banana.out");
int nr, k;
int * gl;
Tp * hash[10000];

int main()
{
  int i;
  unsigned long total = 0;
  Tp * Pi;
  Tl * Pj;

  gl = new int [16000];
  for(i = 0; i < 16000; i++)
    gl[i] = 0;
  input();
  for(i = 0; i < 10000; i++)
    for(Pi = hash[i]; Pi != NULL; Pi = Pi->Pnext)
      gl[Pi->tata->nod]++;
  qsort((void *)gl, 16000, sizeof(int), sf);
  for(i = 0; i < k; i++)
    total += gl[i];
  fout<<total;
  fout.close();
  return 0;
}

void input()
{
  int i, xi, yi, n = 0;
  Tp * f = NULL, * Pi, * g = NULL;

  fin>>nr>>k;
  for(i = 0; i < nr; i++)
  {
    fin>>xi>>yi;
    f = NULL;
    for(Pi = hash[xi]; Pi != NULL; Pi = Pi->Pnext)
      if(Pi->y == yi - 1 || Pi->y == yi + 1)
	if(f != NULL && Pi->tata != f->tata)
	  combine(f->tata, Pi);
	else
	  f = Pi;
    for(Pi = hash[xi - 1]; Pi != NULL; Pi = Pi->Pnext)
      if(Pi->y == yi)
	if(f != NULL && Pi->tata != f->tata)
	  combine(f->tata, Pi);
	else f = Pi;
    for(Pi = hash[xi + 1]; Pi != NULL; Pi = Pi->Pnext)
      if(Pi->y == yi)
	if(f != NULL && Pi->tata != f->tata)
	  combine(f->tata, Pi);
	else f = Pi;
    g = new Tp;
    n++;
    g->nod = n;
    g->x = xi;
    g->y = yi;
    if(f != NULL)
      g->tata = f->tata;
    else
      g->tata = g;
    g->Pnext = hash[xi];
    hash[xi] = g;
  }
}

void combine(Tp * mat, Tp * pat)
{
  int i;
  Tp * Pi;

  pat->tata = mat->tata;
  for(Pi = hash[pat->x]; Pi != NULL; Pi = Pi->Pnext)
    if(Pi != mat && Pi->y == pat->y - 1 || Pi->y == pat->y + 1)
      combine(mat, Pi);
  for(Pi = hash[pat->x - 1]; Pi != NULL; Pi = Pi->Pnext)
    if(Pi != mat && Pi->y == pat->y)
      combine(mat, Pi);
  for(Pi = hash[pat->x + 1]; Pi != NULL; Pi = Pi->Pnext)
    if(Pi != mat && Pi->y == pat->y)
      combine(mat, Pi);
}

int sf(const void * a, const void * b)
{
  if(*(int *)a < *(int *)b) return 1;
  else
    if(*(int *)a == *(int *)b) return 0;
    else
      return -1;
}