#include <stdio.h>
#include <alloc.h>
#include <string.h>

#define MAX 101
#define max(u,v) ((u) > (v) ? (u) : (v))
#define min(u,v) ((u) < (v) ? (u) : (v))

int l[MAX], p[MAX], s[MAX], n, k;

long *a, *b;

unsigned char c[16000];

long answer;

void solve(void);

int main(void)
{
	FILE *fin, *fout;
	int i;

	a = (long *)malloc(16000 * sizeof(long));
	b = (long *)malloc(16000 * sizeof(long));

	fin = fopen("gard.in", "r");
	fscanf(fin, "%d %d", &n, &k);
	for (i = 0; i < k; i++)
	{
		fscanf(fin, "%d %d %d", &l[i], &p[i], &s[i]);
		s[i]--;
	}
	fclose(fin);

	answer = 0;

	solve();

	for (i = 0; i < 16000; i++)
		if (a[i] > answer)
			answer = a[i];

	fout = fopen("gard.out", "w");
	fprintf(fout, "%ld\n", answer);
	fclose(fout);

	free(a);
	free(b);

	return 0;
}

void solve(void)
{
	int i, j, sc, lc, pc, indice;
	long plus, castig;

	memset(a, 0, sizeof(long) * 16000);
	for (i = 0; i < k; i++)
	{
		sc = s[i];
		lc = l[i];
		pc = p[i];
		memcpy(b, a, sizeof(long) * 16000);
		memset(c, 0, sizeof(c));
		for (j = max(sc - lc + 1, 0); j <= sc; j++)
		{
			indice = min(j + lc - 1, n - 1);
			plus = j == 0 ? 0 : a[j - 1];
			castig = (indice - j + 1) * pc;
			if (castig + plus > b[indice])
			{
				b[indice] = castig + plus;
				c[indice] = 1;
			}
		}
		for (j = min(sc + lc - 1, n - 1); j >= sc + 1; j--)
			if (c[j])
				if (b[j] - pc > b[j - 1])
				{
					b[j - 1] = b[j] - pc;
					c[j - 1] = 1;
				}
		for (j = 0; j < n - 1; j++)
			b[j + 1] = max(b[j], b[j + 1]);
		memcpy(a, b, sizeof(long) * 16000);
	}
}
