 #include <stdio.h>
 #include <stdlib.h>
 #include <math.h>
 #define MAX 16001

 struct punct{int x, y;};
 punct far pct[MAX];
 int far p[MAX], rang[MAX], n, k, nr[MAX];
 int hsize;
 unsigned long sol=0;

 int gas_mult(int i)
 { if (i!=p[i]) p[i]=gas_mult(p[i]);
   return p[i];
 }

 void uneste(int a, int b)
 { if (rang[a]>rang[b])
	{ p[b]=a;
	  nr[a]+=nr[b];
	  nr[b]=0;
	} else
	{ nr[b]+=nr[a];
	  nr[a]=0;
	  if (rang[a]>rang[b]) p[a]=b;
	    else p[a]=b, rang[b]++;
	}
 }

 void reuneste(int i, int j)
 { uneste(gas_mult(i), gas_mult(j));
 }

 void rh(int i)
 { int l, r, max;
   l=2*i;r=l+1;max=i;
   if (l<=hsize&&nr[l]>nr[i]) max=l;
   if (r<=hsize&&nr[r]>nr[max]) max=r;
   if (max!=i)
	{ nr[i]=nr[i]+nr[max]-(nr[max]=nr[i]);
	  rh(max);
	}
 }

 int sort_function( const void *a, const void *b)
 { int x1=(*(punct *)a).x, y1=(*(punct *)a).y,
	  x2=(*(punct *)b).x, y2=(*(punct *)b).y;
   if (x1!=x2) return x1-x2;
	else return y1-y2;
 }

 int lookup(int x, int y)
 {  punct  *itemptr;
    punct a;
    a.x=x;a.y=y;
    itemptr = (punct *) bsearch (&a, pct, n+1,
		 sizeof(pct[0]), sort_function);
    if (!itemptr) return 0;
    return (punct *)itemptr-pct;
 }

 void main()
 { int i, j, t;
   FILE *fi=fopen("BANANA.IN", "rt");
   fscanf(fi, "%d %d", &n, &k);
   pct[0].x=0;pct[0].y=0;
   for (i=1;i<=n;i++)
	{ fscanf(fi, "%d %d", &pct[i].x, &pct[i].y);
	  p[i]=i;
	  rang[i]=0;
	  nr[i]=1;
	}
   qsort((void *)pct, n+1, sizeof(pct[0]), sort_function);
   for (i=1;i<=n;i++)
	{ t=lookup(pct[i].x-1, pct[i].y);
	  if (t&&t!=i) if (gas_mult(i)!=gas_mult(t)) reuneste(i, t);
	  t=lookup(pct[i].x+1, pct[i].y);
	  if (t&&t!=i) if (gas_mult(i)!=gas_mult(t)) reuneste(i, t);
	  t=lookup(pct[i].x, pct[i].y+1);
	  if (t&&t!=i) if (gas_mult(i)!=gas_mult(t)) reuneste(i, t);
	  t=lookup(pct[i].x, pct[i].y-1);
	  if (t&&t!=i) if (gas_mult(i)!=gas_mult(t)) reuneste(i, t);
	}
   fclose(fi);
   hsize=n;
   for (i=n/2;i>=1;i--) rh(i);
   for (i=1, sol=0;i<=k;i++)
	{ sol+=nr[1];
	  nr[1]=nr[1]+nr[hsize]-(nr[hsize]=nr[1]);
	  hsize--;
	  rh(1);
	}
   FILE *fo=fopen("BANANA.OUT", "wt");
   fprintf(fo, "%ld", sol);
   fclose(fo);
 }