{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 16384,0,655360}
{                                                       2.05.2002 }
{                             COSMA MIHAI                         }
{                              BistrITZA                          }
{                     http://www.bistritairc.go.ro                }
{                 http://www.rechiniiiaspirator.go.ro             }

program gard;
type muncitor = record
                 l,p,s:longint;
                end;
     santier = array[1..100] of muncitor;

var n,k:longint;
    muncitori:^santier;
    gh:array[1..16000] of integer;


procedure citire;
var fin:text;
    i:longint;
begin
 new(muncitori);
 assign(fin,'GARD.IN'); reset(fin);
 readln(fin,N,K);
 for i:=1 to k do
     readln(fin,muncitori^[i].l,muncitori^[i].p,muncitori^[i].s);
 close(fin);
end;


procedure Sort(l, r: Integer);
var
  i,j:integer;
  x,y:muncitor;
begin
  i := l; j := r; x := muncitori^[(l+r) DIV 2];
  repeat
    while (muncitori^[i].p > x.p) or
          ( (muncitori^[i].p=x.p) and (muncitori^[i].l > x.l)) do i := i + 1;
    while (x.p > muncitori^[j].p) or
          ( (x.p=muncitori^[j].p) and (x.l > muncitori^[j].l)) do j := j - 1;
    if i <= j then
    begin
      y := muncitori^[i]; muncitori^[i] := muncitori^[j]; muncitori^[j] := y;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then Sort(l, j);
  if i < r then Sort(i, r);
end;


procedure ecran;
var i:byte;
begin
 writeln('---------');
 for i:=1 to k do begin
     writeln(muncitori^[i].p:4,' ',muncitori^[i].s:4,' ',muncitori^[i].s:3)
     end;
end;


procedure Heuristica;                  {    imposibil !!!!    }
var start,i,j,pas,pline:longint;
begin

 for i:=1 to k do if gh[muncitori^[i].s]=0 then begin
     pas:=0;pline:=0;
     while (pline<muncitori^[i].l) and
           ((gh[muncitori^[i].s-pas])*(gh[muncitori^[i].s+pas])=0) do begin

           if gh[muncitori^[i].s-pas]=0 then begin
              inc(pline);
              gh[muncitori^[i].s-pas]:=muncitori^[i].p;
              end;

           if (gh[muncitori^[i].s+pas]=0) and (pline<muncitori^[i].l) then
              begin
              inc(pline);
              gh[muncitori^[i].s+pas]:=muncitori^[i].p;
              end;
           inc(pas);
           end;
     end;
end;


procedure scriere;
var fout:text;
    rezultat,i:longint;
begin
 rezultat:=0;
 for i:=1 to n do rezultat:=rezultat+gh[i];
 assign(fout,'GARD.OUT'); rewrite(fout);
  write(fout, rezultat );
 close(fout);
end;

Begin
 Citire;
 sort(1,k);

 Heuristica; {  :)  }
 Scriere;
End.