
{$M 65520,0,655360}

program banana;

const nmax=16010;
      fin='banana.in';
      fout='banana.out';

type point=record
             x,y:integer;
           end;
     list=^cell;

     cell=record
            node:integer;
            next:list;
          end;
     vector=array[0..10005] of integer;
     vp=array[0..nmax] of list;
     v2=array[0..nmax] of integer;

var a:array[0..nmax] of  point;
    poz1,poz2:^vector;
    n,k:integer;
    c:^vp;
    cmp:^v2;
    ct,ncmp:integer;
    nr:^vector;
    sol:integer;


procedure read_in;
var f:text;
    i:integer;
begin
  assign(f,fin); reset(f);
  readln(f,n,k);
  for i:=1 to n do read(f,a[i].x,a[i].y);
  close(f);
end;

procedure Sort(l, r: Integer);
var
  i, j, x, y: integer;
begin
  i := l; j := r; x := a[(l+r) DIV 2].x;
  repeat
    while a[i].x < x do i := i + 1;
    while x < a[j].x do j := j - 1;
    if i <= j then
    begin
      y := a[i].x; a[i].x := a[j].x; a[j].x := y;
      y := a[i].y; a[i].y := a[j].y; a[j].y := y;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then Sort(l, j);
  if i < r then Sort(i, r);
end;

procedure Sort2(l, r: Integer);
var
  i, j, x, y: integer;
begin
  i := l; j := r; x := a[(l+r) DIV 2].y;
  repeat
    while a[i].y < x do i := i + 1;
    while x < a[j].y do j := j - 1;
    if i <= j then
    begin
      y := a[i].x; a[i].x := a[j].x; a[j].x := y;
      y := a[i].y; a[i].y := a[j].y; a[j].y := y;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then Sort2(l, j);
  if i < r then Sort2(i, r);
end;

procedure Sort3(l, r: Integer);
var
  i, j, x, y: integer;
begin
  i := l; j := r; x := nr^[(l+r) DIV 2];
  repeat
    while nr^[i] > x do i := i + 1;
    while x > nr^[j] do j := j - 1;
    if i <= j then
    begin
      y := nr^[i]; nr^[i] := nr^[j]; nr^[j] := y;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then Sort3(l, j);
  if i < r then Sort3(i, r);
end;


procedure process;
var idx,i:integer;
begin
  new(poz1); new(poz2);
  fillchar(poz1^,sizeof(poz1^),0);
  fillchar(poz2^,sizeof(poz2^),0);
  Sort(1,n);
  idx:=1;
  poz1^[a[1].x]:=1; poz2^[a[1].x]:=1;
  repeat
    poz1^[a[idx].x]:=idx;
    while  a[idx+1].x=a[idx].x do inc(idx);
    poz2^[a[idx].x]:=idx;
    if idx=n then break;
    inc(idx);
  until idx=n;
  for i:=1 to 10000 do
    if (poz1^[i]<>0)and(poz2^[i]<>0) then
     sort2(poz1^[i],poz2^[i]);
end;

function bins(lo,hi,x:integer):integer;
var mid:integer;
begin
  if lo=hi then
    if a[lo].y=x then
       begin bins:=lo; exit end
       else   begin bins:=0; exit end;
  mid:=(lo+hi) div 2;
  if x<=a[mid].y then bins:=bins(lo,mid,x)
                 else bins:=bins(mid+1,hi,x)
end;


function  find(x,y:integer):integer;
begin
  find:=bins(poz1^[x],poz2^[x],y);
end;

procedure construct;
var x,y,aux,i:integer;
    q:list;
begin
  new(c);
  for i:=1 to n do c^[i]:=nil;
  for i:=1 to n do begin
    if memavail<10 then begin
      writeln(i);
      break; halt
    end;
    x:=a[i].x; y:=a[i].y;
 {   aux:=0;
    if poz1^[x-1]<>0 then aux:=find(x-1,y);
    if (aux<>0) then  begin
      new(q);
      q^.node:=aux;
      q^.next:=c^[i];
      c^[i]:=q; q:=nil;
      new(q);
      q^.node:=i;
      q^.next:=c^[aux];
      c^[aux]:=q;
    end;  }
    aux:=0;
    if poz1^[x+1]<>0 then aux:=find(x+1,y);
    if (aux<>0) then  begin
      new(q);
      q^.node:=aux;
      q^.next:=c^[i];
      c^[i]:=q; q:=nil;
      new(q);
      q^.node:=i;
      q^.next:=c^[aux];
      c^[aux]:=q;
    end;
    aux:=0;
{    if poz1^[x]<>0 then aux:=find(x,y-1);
    if (aux<>0) then  begin
      new(q);
      q^.node:=aux;
      q^.next:=c^[i];
      c^[i]:=q; q:=nil;
      new(q);
      q^.node:=i;
      q^.next:=c^[aux];
      c^[aux]:=q;
    end;  }
    aux:=0;
    if poz1^[x]<>0 then aux:=find(x,y+1);
    if (aux<>0) then  begin
      new(q);
      q^.node:=aux;
      q^.next:=c^[i];
      c^[i]:=q; q:=nil;
      new(q);
      q^.node:=i;
      q^.next:=c^[aux];
      c^[aux]:=q;
    end;
  end
end;

procedure df(x:integer);
var q:list;
begin
  if cmp^[x]<>0 then exit;
  cmp^[x]:=ncmp;
  q:=c^[x];
  while q<>nil do begin
    df(q^.node);
    q:=q^.next;
  end
end;

procedure parc;
var i:integer;
begin
  ncmp:=0;
  for i:=1 to n do
    if cmp^[i]=0 then begin
      inc(ncmp);
      df(i)
    end
end;

procedure solve;
var i:integer;
    f:text;
begin
  new(nr);
  fillchar(nr^,sizeof(nr^),0);
  for i:=1 to n do inc(nr^[cmp^[i]]);
  sort3(1,ncmp);
  sol:=0;
  for i:=1 to k do inc(sol,nr^[i]);
  assign(f,fout); rewrite(f);
  writeln(f,sol); close(f)
end;

begin
  read_in;
  process;
  construct;
  dispose(poz1); dispose(poz2);
  new(cmp);
  fillchar(cmp^,sizeof(cmp^),0);
  parc;
  solve;
end.