{$M 65000,0,650000}
const maxn=16000; fin='banana.in'; fout='banana.out';
      dx: array[1..4] of integer=(-1,0,1,0);
      dy: array[1..4] of integer=(0,1,0,-1);
type ref=^rec;
     rec=record n: integer; urm: ref; end;
     punct=record i,j: integer; end;
     sirp=array[1..maxn] of punct;
     siri=array[1..maxn] of integer;
var start,stop: ref;
    nr: ^siri;
    sel: array[1..maxn] of boolean;
    p: ^sirp;
    n,rez,kk,nc,aux1: integer;
    aux: punct;

procedure citire;
var f: text;
    i: integer;
begin
  assign(f,fin); reset(f);

  read(f,n,kk);
  for i:=1 to n do read(f,p^[i].i,p^[i].j);

  close(f);
end;

procedure add(i: integer);
var c: ref;
begin
  new(c); stop^.n:=i; stop^.urm:=c; stop:=c;
end;

procedure pop;
var c: ref;
begin
  new(c); c:=start; start:=start^.urm; dispose(c);
end;

function comp(p1,p2: punct): integer;
begin
  if (p1.i=p2.i) and (p1.j=p2.j) then begin comp:=0; exit; end;
  if (p1.i<p2.i) or ( (p1.i=p2.i) and (p1.j<p2.j) ) then
  begin comp:=-1; exit; end
  else begin comp:=1; exit; end;
end;

function cauta(i,j: integer): integer;
var min,max,v,mij: integer;
    pp: punct;
begin
  pp.i:=i; pp.j:=j; min:=1; max:=n;
  while min<=max do
  begin
    mij:=(min+max) div 2;
    v:=comp(p^[mij],pp);

    if v=0 then
    begin cauta:=mij; exit; end;

    if v=-1 then min:=mij+1
    else max:=mij-1;
  end;
  cauta:=0;
end;

procedure cl(s: integer);
var cap,i,j,k,v: integer;
begin
  add(s); sel[s]:=true;
  while start^.urm<>stop do
  begin
    cap:=start^.urm^.n;
    i:=p^[cap].i; j:=p^[cap].j;
    for k:=1 to 4 do
      if (i+dx[k]>=1) and (j+dy[k]>=1) then
      begin
        v:=cauta(i+dx[k],j+dy[k]);
        if v<>0 then
          if not sel[v] then
          begin sel[v]:=true; add(v); inc(nr^[nc]); end;
      end;

    pop;
  end;
end;

procedure Sort(l, r: Integer);
var
  i, j: integer;
  x: punct;
begin
  i := l; j := r; x := p^[(l+r) DIV 2];
  repeat
    while comp(p^[i],x)=-1 do i := i + 1;
    while comp(x,p^[j])=-1 do j := j - 1;
    if i <= j then
    begin
      aux := p^[i]; p^[i] := p^[j]; p^[j] := aux;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then Sort(l, j);
  if i < r then Sort(i, r);
end;

procedure Sort1(l, r: Integer);
var
  i, j,x: integer;
begin
  i := l; j := r; x := nr^[(l+r) DIV 2];
  repeat
    while nr^[i]<x do i := i + 1;
    while x<nr^[j] do j := j - 1;
    if i <= j then
    begin
      aux1 := nr^[i]; nr^[i] := nr^[j]; nr^[j] := aux1;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then Sort1(l, j);
  if i < r then Sort1(i, r);
end;

procedure solve;
var i: integer;
begin
  nc:=0; fillchar(sel,sizeof(sel),false); fillchar(nr^,sizeof(nr^),0);
  sort(1,n);
  for i:=1 to n do
    if not sel[i] then
    begin
      inc(nc); nr^[nc]:=1;
      cl(i);
    end;

  sort1(1,nc); rez:=0;
  for i:=nc downto nc-kk+1 do
    rez:=rez+nr^[i];
end;

procedure scrie;
var f: text;
begin
  assign(f,fout); rewrite(f);
  write(f,rez);
  close(f);
end;

Begin
  new(start); new(stop); start^.urm:=stop;
  new(p); new(nr);

  citire;
  solve;
  scrie;
End.